* Generated from unix host version
* Better edit that ( xepb.org/dtz/68kavr.html )
* When you ll try to get source for assembling on CP/M, uncomment this line,
* find one more include in the text and replace them with #include
* and run via Linux cpp
*
*
* The other include looks like
* 'include "dph.asm"'
* And should look like
* '#include "dph.asm"'
*
*
* Then
* cpp bios.asm > bios_out.asm
* and run out2cpm.tcl
*
*
*
* Do not forger to Edit MEMRGN!
* (YOU should not if you are not building BIOS for anything
* different from SRecord bios to be used with CP/M 1.3 $15000,
* or onboard 128M and 256M RAM systems)
*
* Then, delete all lines started with '# '.
* Next, add ^M, ^Z, and change all the '*'s by '*' and you are done *-)
* You can use out2cpm.tcl script for that.
*
*
* If you assemble that onboard, keep the files on B: and do smth like
* that:
*C:
*AS68 B:DTZBIOS.S
*LO68 -R -UCPM -O B:CPM.REL CPMLIB B:DTZBIOS.O
*SIZE68 B:CPM.REL (just to watch you can fit in the desired space)
*reloc -b18000 b:cpm.rel b:cpm.sys
* , (or -b38000 for 256K system) then copy b:cpm.sys to a:
*
* Note: for 256K versions, reloc to 38000
*
* Part I - assembling options
*
* define if BIOS should be compiled as SRecord stand-alone file (to be
* assembled on the 1 host)
ASSREC equ 0
*
* 256K mem * overwise, 128K. Only valid for ASSREC = 0 and for not CPMLDR
MEM256K equ 1

* create an CPMLDR bios instead
ASCPLDR equ 0

*
* Part II - SD and SD DEBUG options
*
* Should work (should be set to 0 if SD!)
SDHC equ 1
*
* Without this, BIOS will write and read every CP/M sector by
* reading / writing the whole SD sector.
* I do not use the true deblocking algorythm, but this setting will prevent
* reading sectors if they are allready in memory
* Recommended

SDRC equ 1

* Some debug options

*Writes info of sector read and written
SDSECD equ 0

* Huge write debug
SDWDGB equ 0

* Bios messages on what has failed, recommended
SDVERER equ 1

* Raise CS and drop CS, new feature, looks like working,
* unclear should you do it or not.
SD_ONOFF EQU 1

*
* Issue CMD13 after sector write
* Normally you want it, but it takes some bytes.
USECMD13 equ 1
*
* Writes 'wwwww' and 'rrrr' on every $8000 write/read attempts
* Better leave it on.
SDWLONGO equ 1

*
* Traces all bios calls *-) (except 1 2 3 4)
TOBCS equ 0

*
* Part III - CP/M settings
*
* Max Disks
* Only one for CPMLDR
 IFNE ASCPLDR
maxdsk equ 1
 ENDC
* As much as we can for system itself
 IFEQ ASCPLDR
maxdsk equ 16
 ENDC

* Length of DPH (Refer to Sysguide)
dphlen equ 26

*
* Part VI - Hardware defs
*
* this defines specific to 68kavr

* AVR- based UART.
uartstat equ $FF7A0002
uartdata equ $FF7A0000
* our console on AVR device
* the other alternative is DUART (see later)
CONSAVR equ 1
*
* Attempt to do iobyte
IOBYTE equ 1
* To make (for whatever reason) slowclk-only system,
* use 0 as both values
slowclk equ $FF7C0000
fastclk equ $FF7E0000
*
* SD card hardware settings.
sd_port equ $FF780000
SD_CMD17 equ $51
SD_CMD13 equ $4D
SD_CMD24 equ $58
*
* If we have 68681 DUART
DUART equ $FF790000
* If we do not have DART use
*DUART equ 0
* Use duart only if software jumper set
* Software jumper is (sd_port) bit 1* if card with DUART
* present, should give 0
* Can be used only when DUART and IOBYTE is set
SWJUMP1 equ 1
*
* If the console on DUART A - must be 1 or 0.
* There can be only one console - CONSDA or CONSAVR
* Should be used when DUART is set and IOBYTE is not set
CONSDA equ 0
*
DUMR1A equ 0 * W:Mode register 1 chan A
DUMR2A equ 0 * W:--
DUCSRA equ 2 * W:Clock select register
DUSRA equ 2 * R:Status register
DUCRA equ 4 * W:command register
DUTBA equ 6 * W:Tx buffer
DUACR equ 8 * hm, right?

DUMR1B equ $10 * W:Mode register 1 chan B
DUMR2B equ $10 * W:--
DUCSRB equ $12 * W:Clock select register
DUSRB equ $12 * R:Status register
DUCRB equ $14 * W:command register
DUTBB equ $16 * W:Tx buffer

DUOPCR equ $1A * W: 0x0D * 2 * Outport port cfg
DUOP equ $1C * W: 0x0E * 2 * Output port set
DUOPR equ $1E * W: 0x0F * 2 * Ourput port reset

* Speed:
* $CC 38400
* $88 2400
* $66 1200
DUASPEED equ $CC

* END OF SETTINGS

* if we are assembled as SRECORD, all the ORGS are absolute
* (taken from CPM15000.MAP file)
 IFNE ASSREC
 org $1B000
* For 1.3
_ccp equ $150BC
* For 1.2 _ccp equ $150B8
*_init equ $1B000
 ENDC

* if not - compile as .o
 IFEQ ASSREC
 .text
 .globl _init
 IFEQ ASCPLDR * CPMLDR Does not need _ccp
 .globl _ccp
 ENDC
* section 0
 ENDC

************************************* ENTRY POINT ***********************************

********** Normal BIOS init
 IFEQ ASCPLDR
* This code is directly from "CP/M 68 System Guide" page 59
 EVEN
* if srecord, _init is defined in CPM15000.SR, so we do not need define it here
* and it is defined as 1B000, so ORG 1B000 matters
_init:
 bsr hwinit
 move.l #biosmsg,a0
 bsr tx_str
 move.l #entry,($8c)
* installing trap #3 handler , so I suppose CP/M talks with bios
* with this trap
 clr.l d0 * log on disk A,user 0
 rts
 ENDC
*not an cpmldr bios

*********** CPMLDR BIOS
 IFNE ASCPLDR
 .globl _bios
* if its a CPMLDR BIOS, do almost nothing ("CP/M 68 System Guide" page 10)
_init:
* Why the fuck AS68 complains to this IFNE while assembling
* with ASCPLDR as 0 ??
 bsr hwinit
 move.l #biosmsg,a0
 bsr tx_str
 rts

_bios: * if called as CPMLDR BIOS - call this way
bios: * via _bios globl this entry point
 ENDC
*


entry: * here we get control when trap #3 executed
* if >=2 and <= 4 skip
 IFNE TOBCS
 cmpi.b #4,d0
 ble intryst
 move.l a1,-(sp)
 move.l d1,-(sp)
 move.l d0,-(sp)
 move.l #bcmsg,a0
 bsr tx_str
 move.l (sp)+,d0
 move.l d0,-(sp)
 bsr tx_w
 move.l (sp)+,d0
 move.l (sp)+,d1
 move.l (sp)+,a1
intryst:
 ENDC

 cmpi.w #nfuncs,d0
 bcc trapng
 andi.l #$00FF,d0
 lsl #2,d0 * multipling d0 x 4
 move.l #biosbase,a0
 adda.l d0,a0
 move.l (a0),a0
 jsr (a0)
trapng:
 IFNE ASCPLDR
 rts * if its a CPMLDR BIOS, return with RTS
 ENDC
 IFEQ ASCPLDR
 rte * If not - return from a TRAP
 ENDC
* ******************* That was BIOS entry point, now the jump table ******************
biosbase:
 dc.l _init
 dc.l wboot
 dc.l constat
 dc.l conin
 dc.l conout * 4
 dc.l lstout
 dc.l pun
 dc.l rdr
 dc.l home
 dc.l seldsk * 9
 dc.l settrk * 10 A
 dc.l setsec * 11 B
 dc.l setdma * 12 C
 dc.l read * 13 D
 dc.l write * E
 dc.l listst * F
 dc.l sectran * 16 10
 dc.l setdma * 17 11
 dc.l getseg * getmrt,18 12
 dc.l getiob *19 13
 dc.l setiob * 20 14
 dc.l flush * 21 15
    dc.l setexc * 22 16

nfuncs equ (*-biosbase)/4

******************* BIOS Functions themselfs **************************************

wboot:
 IFNE ASCPLDR * CPMLDR BEHAVES THIS WAY
 rts
 ENDC
 IFEQ ASCPLDR
 jmp _ccp
 ENDC

**********************************************
* CONSTAT
**********************************************
 IFNE DUART
constdu:
 move.l a0,-(sp) * pushing A0 to stack
 movea.l #DUART,a0
 clr.w d0
 move.b DUSRA(a0),d0
 move.l (sp)+,a0 * restoring it back
* btst.b #0,d0 * returns zero if no char (AS68 dislike that)
 andi.b #1,d0
 rts
 ENDC

constavr:
 clr.w d0
 move.b d0,(slowclk) * switching clock slow
 move.b (uartstat),d0
 move.b d0,(fastclk) * switching clock fast
 andi.b #$02,d0 * bit 1 is 1?
 lsr #1,d0 * hope this will return 1 if is
 rts

constat:
* bne constavr
*------------------ Test input for a char
* return 1 in d0 if we have a char in input

* if we care about iobyte
 IFNE IOBYTE
 IFNE SWJUMP1
 btst #1,sd_port * 0 if card present
 bne constavr * if absent - use avr only
 ENDC

 tst.w iob * if we have iobyte, test it
 beq constavr *if thats 0, use avruart
 bra constdu * or test duart
 ENDC

* end the iobyte

* if we do not use iobyte
 IFEQ IOBYTE

 IFNE DUART
 IFNE CONSDA
* and our console on duart
 bra constdu
 ENDC
 ENDC
* if it is on avr
 IFNE CONSAVR
 bra constavr
 ENDC

 ENDC
* endc iobyte

*********************************************
* CONIN
**********************************************
* Conin Duart
 IFNE DUART
conindu:
 bsr constdu * Waiting for byte to came
 beq conindu *

 move.l a0,-(sp) * pushing A0 to stack
 movea.l #DUART,a0
 move.b DUSRA(a0),d0 * do we have some error?
 and.b #$F0,d0 * Saying, overflow?
 beq coninne * con-in-no-err

 move.w #$50,DUCRA(a0) * Clearing error condition in DUART
 move.w #$40,DUCRA(a0) *
 move.w #$30,DUCRA(a0) *
 move.w #$20,DUCRA(a0) *
coninne:
 clr.w d0
 move.b DUTBA(a0),d0
 move.l (sp)+,a0 * restoring it back
 rts
 ENDC

coninavr:
 bsr constavr * wait for byte to came from avr
 beq coninavr
 clr.w d0
 move.b d0,(slowclk) * switching clock slow
 move.b (uartdata),d0 * read from uart
 move.b d0,(fastclk) * switching clock fast
 rts

conin:
* bra coninavr
* if we care about iobyte
 IFNE IOBYTE
* if we care about jumper
 IFNE SWJUMP1
 btst #1,sd_port * 0 if card present
 bne coninavr * if absent - use avr only
 ENDC
 tst.w iob * if iobyte is zero
 beq coninavr * use avr
 bra conindu * if not, use DUART
 ENDC
* end of iobyte

* if we do not care about iobyte
 IFEQ IOBYTE
 IFNE CONSDA
 bra conindu
 ENDC

* *** AVR
 IFNE CONSAVR
 bra coninavr
 ENDC
 ENDC
* ^^^^^ IOB
* in CP/M System guide
* and.l #$7F,d0

**********************************************
*CONOUT
**********************************************
** conout on avr
coutavr:
 move.b d0,(slowclk) * switching clock slow
 move.b (uartstat),d0 * getting UART TX READY status
 move.b d0,(fastclk) * switching clock fast
 andi.b #$01,d0
 bne coutavr * not clear to send
 move.b d0,(slowclk) * switching clock slow
 move.b d1,(uartdata) * writing byte
 move.b d0,(fastclk) * switching clock fast
 rts
**********************************************
** counout on uart A
 IFNE DUART
coutuaa:
 move.l a0,-(sp)
 movea.l #DUART,a0
coutua1:
 btst.b #2,DUSRA(a0)
 beq coutua1
 move.b d1,DUTBA(a0)
 move.l (sp)+,a0
 rts
 ENDC

*******
conout:
* if we care about IOBYTE
 IFNE IOBYTE
* if we care about jumper
 IFNE SWJUMP1
 btst #1,sd_port * 0 if card present
 bne coutavr * if absent - use avr only
 ENDC
 tst.w iob
 beq coutavr * if zero - output to avr console
 bra coutuaa * output on uart
* and do not care about rts even
 ENDC

* if we do not
 IFEQ IOBYTE
 IFNE CONSDA
 bra coutuaa
 ENDC

 IFNE CONSAVR
 bra coutavr
 ENDC
 ENDC
* end of no-iobyte


**********************************************
lstout:
 IFNE DUART
 bra coutuaa
 ENDC
 rts

* IFNE DUART
* IFEQ CONSDA * If DUART is not console
* move.l a0,-(sp)
* movea.l #DUART,a0
*lstout1:
* btst.b #2,DUSRA(a0)
* beq lstout1
* move.b d1,DUTBA(a0)
* move.l (sp)+,a0
* ENDC
* ENDC
* rts

**********************************************
pun:
        IFNE DUART
        bsr lstout
        ENDC
 rts
**********************************************
rdr:
        IFNE DUART
 IFNE SWJUMP1
 btst #1,sd_port * 0 if card present
 beq conindu
 rts * if card is absent - just return
 ENDC
 bra conindu * or just input from uart
 ENDC
 rts * just return if we have not DUART

**********************************************

home:
 clr.b track
 rts

**********************************************
seldsk: * select disk given by register d1.b
 moveq #0,d0
 cmp.b #maxdsk,d1
********************** bpl selrtn
 bge selrtn
 move.b d1,seldrv
 move.b d1,d0
 mulu #dphlen,d0
 add.l #dph0,d0 * returning correct dph
selrtn: * return from seldsk
 rts

**********************************************
* ACHTUNG ACHTUNG! IN SG, TRACK IS TWO BYTES!
* IN CP/M 68, looks like there is only 1 BYTE!
settrk:
 move.w d1,track * max 65535 (page 25 of system manual)
 rts
**********************************************
setsec:
 move.w d1,sector * nothing said about maximum, but it is .w (page 26 of system manual)
 rts

**********************************************
setdma:
 move.l d1,dma
 rts

**********************************************
* read one sector to dma address
* d0 == 00 if ok
read:
 IFNE ASCPLDR
 move.b #".",d1 *
 bsr conout *
 ENDC
 IFEQ SD_ONOFF
 bsr sd_on
 ENDC
 IFNE SDSECD
 move.l #rtmsg,a0
 bsr tx_str
 move.b seldrv,d1 *
 bsr tx_hex *
 move.b #":",d1 *
 bsr conout *
 move.w track,d0 *
 bsr tx_w *
 move.b #":",d1 *
 bsr conout *
 move.w sector,d0 *
 bsr tx_w *
 move.l #crlf_msg,a0 *
 bsr tx_str *
 ENDC

 bsr setlba

 IFNE SDRC
* debug - delete it
*move.l d0,-(sp)
*move.l #reading_track_comparing,a0
*bsr tx_str
*move.l sectwas,d0
*bsr tx_l
*move.l (sp)+,d0
* up to here

 cmp.l sectwas,d0 * was this sector
* read before?
 beq readskip
 move.l d0,-(sp) * pushing lba to stack
* move.l #reading_track_msg_really,a0
* bsr tx_str
 ENDC

 bsr sdrscd0
 cmpi.w #$0,d0
 beq read_ok
* sector was not read ok
 IFNE SDRC
 move.l (sp)+,d1 * popping lba from stacl
 move.l #$FFFFFFFF,sectwas
 ENDC
* and by the way a0.w still holds 1
 IFEQ SD_ONOFF
 bsr sd_off
 ENDC
 rts


read_ok:

 IFNE SDRC
* move.l (sp)+,d0 * sectwas * poping lba from stack
* move.l d0,sectwas *
* bsr tx_l
 move.l (sp)+,sectwas * poping lba from stack
* and storing it,as sector was read sucessfuly
* bra srkpnmsg
readskip:
 IFNE SDSECD
 move.l #rsmsg,a0
 bsr tx_str
 ENDC
*srkpnmsg:
 ENDC

 IFNE SDSECD
 move.b #'&',d1
 bsr conout
 ENDC
 move.w sector,d0
 andi.l #3,d0

 IFNE SDSECD
 move.l d0,-(sp) * showing two last bits
 bsr tx_l
 move.l (sp)+,d0
 ENDC

 lsl.l #7,d0 * multiply 128

 IFNE SDSECD
 move.l d0,-(sp) * showing offset
 bsr tx_l
 move.l (sp)+,d0
 ENDC

 add.l #sd_sector,d0

 move.l d0,a0 * our buffer + offset of number of cp/m sector
 IFNE SDSECD
 move.b #'%',d1
 bsr conout
 ENDC


    IFNE SDSECD
    move.l a0,d0
    bsr tx_l
    ENDC


    move.l dma,a1 * copying actually CP/M sector from our SD sector to
* DMA
    move.w #$7F,d4 * length of CP/M sector size - 1
readtxb:
    move.b (a0)+,(a1)+ * I mean (a0)->(a1)
    dbra d4,readtxb

* IFNE SDSECD
* move.l #rtwrok,a0
* bsr tx_str
* ENDC

* clr.l d0
    IFEQ SD_ONOFF
    bsr sd_off
    ENDC
    move.w #0,d0
    rts


write: * first, reading the whole track
    IFEQ ASCPLDR
    IFNE SDSECD
* IFNE SDWDGB
    move.l #rdwrmsg,a0
    bsr tx_str
    move.b seldrv,d1 *
    bsr tx_hex *
    move.b #":",d1 *
    bsr conout *
    move.w track,d0 *
    bsr tx_w *
    move.b #":",d1 *
    bsr conout *
    move.w sector,d0 *
    bsr tx_w *
    move.l #crlf_msg,a0 *
    bsr tx_str *
    ENDC

    IFEQ SD_ONOFF
     bsr sd_on
    ENDC
    bsr setlba
    IFNE SDRC
    cmp.l sectwas,d0 * is the sector with this LBA allready in buffer?
    beq wrtrdskp
    move.l a0,-(sp) * storing LBA to stack
    ENDC
* move.l d0,d6 * we do not use d6, right? Nooo!


    bsr sdrscd0
    cmpi.w #$0,d0
    beq wread_ok
* sector was not read ok
    IFNE SDRC
    move.l (sp)+,d1 * popping lba from stack
    move.l #$FFFFFFFF,sectwas
    ENDC
    IFNE SDVERER
    move.l #wcnrmsg,a0
    bsr sdvmsg
    ENDC
    IFEQ SD_ONOFF
     bsr sd_off
    ENDC
* and by the way d0.w still holds 1 and indicates error
    rts

wread_ok:
    IFNE SDRC
    move.l (sp)+,sectwas * poping lba from stack and storing it
* saying this sector was sucessfuly read
    bra wrtrdsnm
    ENDC


wrtrdskp:
    IFNE SDSECD
    move.l #rsmsg,a0
    bsr tx_str
    ENDC

wrtrdsnm:
* IFNE SDWDGB
    IFNE SDSECD
    move.b #'@',d1
    bsr conout
    ENDC
    move.w sector,d0
    andi.l #3,d0

    IFNE SDSECD
* IFNE SDWDGB
    move.l d0,-(sp) * showing two last bits
    bsr tx_l
    move.l (sp)+,d0
    ENDC

    lsl.l #7,d0 * multiply 128

    IFNE SDSECD
* IFNE SDWDGB
    move.l d0,-(sp) * showing offset
    bsr tx_l
    move.l (sp)+,d0
    ENDC

    add.l #sd_sector,d0
    move.l d0,a0 * our buffer + offset of number of cp/m sector

    IFNE SDSECD
* IFNE SDWDGB
    move.b #'#',d1
    bsr conout
    move.l a0,d0
    bsr tx_l
    ENDC

* so, we have a0 poining to where we will copy dma
    move.l dma,a1
    move.w #$7F,d4 * length of CP/M sector size - 1
writtxb:
    move.b (a1)+,(a0)+ * I mean (a1)->(a0)
    dbra d4,writtxb

    IFNE SDSECD
* IFNE SDWDGB
    move.l #wtmsg,a0
    bsr tx_str
    move.b seldrv,d1 *
    bsr tx_hex *
    move.b #":",d1 *
    bsr conout *
    move.w track,d0 *
    bsr tx_w *
    move.b #":",d1 *
    bsr conout *
    move.w sector,d0 *
    bsr tx_w *
    move.l #crlf_msg,a0 *
    bsr tx_str *
    ENDC


* and now we have to write whole the sd_sector to sector
    bsr setlba
    move.b #SD_CMD24,d1
    bsr sdwrtca * sending command

* waiting for 00
* move.w #$7FFF,d5
*writloop3:
    move.w #$7FFF,d4
* move.w #$80,d4
wrtlp31:
    IFNE SDWDGB
    bsr sdrbdb * will return in D0
    ENDC
    IFEQ SDWDGB
    bsr sdrb * will return in D0
    ENDC

    cmpi.b #$00,d0
    beq wrtl3ex * got ok to write
    dbra d4,wrtlp31
* dbra d5,writloop3

    IFNE SDRC
    move.l #$FFFFFFFF,sectwas
    ENDC

    IFNE SDVERER
    move.l #wcnrems,a0
    bsr sdvmsg
    ENDC
    IFEQ SD_ONOFF
    bsr sd_off
    ENDC
    move.w #1,d0 * cannot get 00 - "ready to write" mark
    rts

wrtl3ex: * write loop 3 exit

* move.w #7,d4
*wrtl3el:
    move.b #$FF,d1
    bsr sdwrbd * eight byte gap
* dbra d4,wrtl3el

    move.b #$FE,d1
    bsr sdwrbd * starting data

    move.l #sd_sector,a0 * writing SD sector itself
    move.w #$1FF,d4 * #200 bytes of sector data -1
wrtlp4:
    move.l d4,-(sp) *DELETE THIS PUSH?
    move.b (a0)+,d1
    IFNE SDWDGB
    bsr sdwrbq
    ENDC
    IFEQ SDWDGB
    bsr sdwrbd
    ENDC
    move.l (sp)+,d4 * DELETE THIS POP?
    dbra d4,wrtlp4

* here we transferred whole 1 SD track (4 CPM tracks) in sd_sector
    clr.b d1
    bsr sdwrbd
    clr.b d1
    bsr sdwrbd * checksumm - 2 bytes, noone cares

* waiting SD to accept sector
    move.w #$7FFF,d5
writeacc1:
    move.w #$7FFF,d4
wrtacl2:
    move.l d5,-(sp) *DELETE THIS PUSH?
    move.l d4,-(sp) *DELETE THIS PUSH?
    IFNE SDWDGB
    bsr sdrbdb * will return in D0
    ENDC
    IFEQ SDWDGB
    bsr sdrb * will return in D0
    ENDC
    move.l (sp)+,d4 * DELETE THIS POP?
    move.l (sp)+,d5 * DELETE THIS POP?

    andi.b #$1F,d0
    cmpi.b #5,d0
    beq wrtaccpt

* cmpi.b #0,d0
* beq wrtaclr

* cmpi.b #$F,d0
* ble wrtbnoa * we have got the result, but
* it shows some error

* andi.b #$E,d0
* cmpi.b #4,d0
* beq wrtaccpt

wrtaclr:
* write accepted loop repeat
    dbra d4,wrtacl2
    IFNE SDWLONGO
    move.b #"w",d1
    bsr conout
    ENDC
    dbra d5,writeacc1


wrtbnoa:
    IFNE SDRC
    move.l #$FFFFFFFF,sectwas * Wrong write
    ENDC
    IFNE SDVERER
    bsr tx_hex
    move.l #wbnamsg,a0
    bsr sdvmsg
    ENDC
    IFEQ SD_ONOFF
    bsr sd_off
    ENDC
    move.w #1,d0 * data was not accepted
    rts

* data packet was accepted and ready to be written
wrtaccpt:
* In case it takes a LOOONG time, uncomment this and
* dbra d5,here
    move.w #$7FFF,d5
writefinl:
    move.w #$7FFF,d4 * and now just wait for 0
* move.w #$80,d4 * and now just wait for **NOT!!** 0
wrtfin12:
    move.l d5,-(sp) *DELETE THIS PUSH?
    move.l d4,-(sp) *DELETE THIS PUSH?
* bsr sdrb
    IFNE SDWDGB
    bsr sdrbdb * will return in D0
    ENDC
    IFEQ SDWDGB
    bsr sdrb * will return in D0
    ENDC
    move.l (sp)+,d4 * DELETE THIS POP?
    move.l (sp)+,d5 * DELETE THIS POP?
    cmpi.b #0,d0 * "Non zero byte to be returned"!
*http:
    bne write_ok * 20141122 was beq!
    bsr hdelay
    dbra d4,wrtfin12
    dbra d5,writefinl

    IFNE SDRC
    move.l #$FFFFFFFF,sectwas
    ENDC
    IFNE SDVERER
    move.l #wdnwmsg,a0
    bsr sdvmsg
    ENDC
    IFEQ SD_ONOFF
    bsr sd_off
    ENDC
    move.w #1,d0 *could not wait for data accpt
    rts
* data block accepted and tried to program
write_ok:

*CMD13 *********************************************
    IFNE USECMD13

    move.b #SD_CMD13,d1 * query status of prev command
    clr.l d0
    bsr sdwrtca * sending command
    move.w #$1000,d4
wrtok1ys:
* IFNE SDWDGB
    IFNE SDWDGB
    bsr sdrbdb * will return in D0
    ENDC
    IFEQ SDWDGB
    bsr sdrb * will return in D0
    ENDC
    cmpi.b #$ff,d0
    bne wrtok1e * if not FF -> exit
    dbra d4,wrtok1ys
* we have first byte of CMD13s R2 reply in d0 - right or wrong
wrtok1e:
    lsl.w #8,d0
    move.w d0,d7
    IFNE SDWDGB
    bsr sdrbdb * getting the second byte of R2 reply of CMD13
    ENDC
    IFEQ SDWDGB
    bsr sdrb
    ENDC
    add.w d7,d0
* move.w d0,-(sp) * Holds FIRSTSECOND byte of R2
* bsr tx_w
* move.l #crlf_msg,a0 *
* bsr tx_str *
* move.w (sp)+,d0
    cmpi.w #0,d0
    beq wrtokfin

    IFNE SDVERER
    bsr tx_w * was tx_hex * both bytes of CMD13
    move.l #wcmd13sm,a0 * "Cmd13 status wrong"
    bsr sdvmsg
    ENDC
    IFEQ SD_ONOFF
    bsr sd_off
    ENDC
    move.w #1,d0 *could not wait for data accpt
    rts


wrtokfin:
    IFNE SDRC *
    bsr setlba * the write is ok, recalculating LBA
    move.l d0,sectwas * and storing it
    ENDC
* vv CMD13_AFTER_WRITE
    ENDC
*



* bsr sdrbdb * will return in D0
* bsr sdrbdb * will return in D0
* bsr sdrbdb * will return in D0
* bsr sdrbdb * will return in D0

    IFEQ SD_ONOFF
    bsr sd_off
    ENDC
    clr.l d0
    ENDC
****^^^ This is if not CPMLDR
    rts

**********************************************
listst:
 IFNE DUART
 IFEQ CONSDA * if console not on DUART
 move.l a0,-(sp) * pushing A0 to stack
 movea.l #DUART,a0
 move DUSRA(a0),d0
 move.l (sp)+,a0 * restoring it back
 andi.b #1,d0 * 1 if ready to send -> must return FF
 beq liststnr
 move.w #0,d0
 rts
 ENDC
 ENDC
liststnr: * stupid AS68 does not like if this label
* before the ENDC
    move.w #$ff,d0
    rts
**********************************************
sectran: * return in D0
    move.l d1,d0 * sector D1 translated via table pointed by d2
    rts
*setdma:
getseg:
    move.l #memrgn,d0
    rts

getiob:
   IFNE IOBYTE
   move.w iob,d0
   ENDC
   rts

setiob:
    IFNE IOBYTE
    move.w d1,iob
    ENDC
    rts

flush:
    clr.l d0
    rts

setexc: * installing interrupt vector
* move.l d1,-(sp)
* move.b #$0D,d1
* bsr conout
* move.b #$0A,d1
* bsr conout
* move.b #'&',d1
* bsr conout
* move.b #'&',d1
* bsr conout
* move.l (sp)+,d1
    andi.l #$FF,d1 *
    lsl #2,d1 * multiply *4
    movea.l d1,a0
    move.l (a0),d0
    move.l d2,(a0)
* move.b #$0D,d1
* bsr conout
* move.b #$0A,d1
* bsr conout
* move.b #'*',d1
* bsr conout
* move.b #'*',d1
* bsr conout
    rts
* My function of calculating LBA of track/sector/seldrv


setlba:
    clr.l d4 * Here will be LBA
    clr.l d0
    move.w sector,d0 * we have $80 CP/M sec/track
    andi.w #$FC,d0 * 4 CP/M track for our SD 512 sec/track
    lsl.l #7,d0
    add d0,d4 * .w? looks ok

    clr.l d0 * adding track
    move.w track,d0
    swap d0
    lsr.l #2,d0
    add.l d0,d4


    clr.l d0
    move.b seldrv,d0
    swap d0
    lsl.l #7,d0

    add.l d0,d4 * have everything in d4* why not addl.l d4.d0?

    IFNE SDHC
    lsr.l #8,d4 * really? 20 -> 01 for the sec 1
    lsr.l #1,d4 * looks like that
    ENDC

    IFNE SDSECD
    move.l d4,d0
    bsr tx_l
    ENDC


    move.l d4,d0
    move.l d0,lastlba

    rts


* waits for byte in d0 d1 times with error message in a0
* why do not to use this nice function somewhere?
wrford0:
    IFNE SDWDGB
    bsr sdrbdb * will return in D0
    ENDC
    IFEQ SDWDGB
    bsr wrtfor0o * will return in D0
    ENDC
    dbra d4,wrford0
    IFNE SDRC
    move.l #$FFFFFFFF,sectwas
    ENDC
    IFNE SDVERER
    bsr sdvmsg
    ENDC
    move.w #1,d0 *could not wait for data accpt
    rts
wrtfor0o:
* clr.w d0
    rts

* writes SD command D1, with arguments D0
sdwrtca:

* should be there "write FF"? It MUST
  move.l d0,d7
  move.l d1,d6

  IFNE SDWDGB
  move.b #13,d1
  bsr conout

  ENDC
  move.b #$FF,d1 * lets do it several times
  bsr sdwrbd * FF
* move.b #$FF,d1
* bsr sdwrbd * FF
* move.b #$FF,d1
* bsr sdwrbd * FF
* move.b #$FF,d1
* bsr sdwrbd * FF
* move.b #$FF,d1
* bsr sdwrbd * FF
* move.b #$FF,d1
* bsr sdwrbd * FF
* move.b #$FF,d1
* bsr sdwrbd * FF
* move.b #$FF,d1
* bsr sdwrbd * FF

  move.l d6,d1
  bsr sdwrbd * command

  move.l d7,d1
  rol.l #8,d1
  move.l d1,d7
  andi.b #$ff,d1
  bsr sdwrbd * first byte of arguments

  move.l d7,d1
  rol.l #8,d1
  move.l d1,d7
  andi.b #$ff,d1
  bsr sdwrbd * second byte of arguments

  move.l d7,d1
  rol.l #8,d1
  move.l d1,d7
  andi.b #$ff,d1
  bsr sdwrbd * third byte of arguments

  move.l d7,d1
  rol.l #8,d1
  move.l d1,d7
  andi.b #$ff,d1
  bsr sdwrbd * forth byte of arguments

  move.b #$95,d1
  bsr sdwrbd * second byte of arguments
  rts

* writes byte quiet
  IFNE SDWDGB
sdwrbq:
  move.l d3,-(sp)
  bra sdwbsa
  ENDC


* writes byte D1
sdwrbd:
* andi.l #$000000FF,d1 * that should be byte * but looks like thats not needed
  move.l d3,-(sp)

  IFNE SDWDGB
  move.b d1,-(sp)
  move.b #'[',d1
  bsr conout
  move.b #'W',d1
  bsr conout
  move.b #':',d1
  bsr conout
  move.b (sp)+,d1
  move.b d1,-(sp)
  bsr tx_hex
  move.b (sp)+,d1
  cmpi.b #$20,d1
  ble sdwbsa
  bsr conout
sdwbsa:
  ENDC
* down to here
  move.w #7,d3 * 8 bits in byte

sdwbl:

    move.b #0,d0
    add.b d1,d1
    addx.b d0,d0 * should add X==Carry flag,
    add.b d0,d0 * 2 or 0
    move.b d0,sd_port * cs=0 data=data clock=0
    add.b #$1,d0
    move.b d0,sd_port * cs=0 data=data clock=1
    subi.b #$1,d0
    move.b d0,sd_port * cs=0 data=data clock=0
    dbra d3,sdwbl


  IFNE SDWDGB
  move.b #']',d1
  bsr conout
  ENDC

  move.l (sp)+,a3
  rts



* returns on D0
sdrb:
    move.l d3,-(sp)
    move.w #7,d3

    move.b #$0,d0 * here will be byte stored
sdrbit:
    add.b d0,d0 * shifting it left
    move.b #3,sd_port * cs=0,data=1,clk=1

    move.b sd_port,d1 * reading inverted data
    andi.b #1,d1 * the lower bit is input
    eori.b #1,d1 * we have an inverted data

    add.b d1,d0 * adding to result
    move.b #2,sd_port * cs=0,data=1,clk=0


    dbra d3,sdrbit
    move.l (sp)+,d3
    rts

  IFNE SDWDGB
sdrbdb:
    bsr sdrb
    move.b d0,-(sp)
    move.b #'(',d1
    bsr conout
    move.b #'R',d1
    bsr conout
    move.b #':',d1
    bsr conout
    move.b (sp)+,d1
    move.b d1,-(sp)
    bsr tx_hex
    move.b #')',d1
    bsr conout
    move.b (sp)+,d0
* move.l (sp)+,d3
    rts
    ENDC



*
* Reads SD sector. Input - LBA in A as setlba returns it.
* Output - d0.w = 1 - is a error, d0.w = 0 - no error
sdrscd0:

    move.b #SD_CMD17,d1
    bsr sdwrtca

* PARANOIA MODE 20141119
    move.w #$7F,d5 * waiting for command accepted
sdrs01:
*

    move.w #$7FFF,d4 * waiting for command accepted

sdrslp:
    IFNE SDWDGB
    bsr sdrbdb * will return in D0
    ENDC
    IFEQ SDWDGB
    bsr sdrb * will return in D0
    ENDC
    cmpi.b #0,d0
    beq sdrslpe * read sucessfull

* cmpi.b #$FF,d0 Whaaaaaaaaaaaaaaaaaaat?
* bne sdrslpe

    dbra d4,sdrslp
    IFNE SDWLONGO
    move.b #'R',d1
    bsr conout
    ENDC
* PARANOIA MODE 20141119
    dbra d5,sdrs01
* PARANOIA MODE 20141119

* we get here if we are unable to get 0 from cmd17 command
    IFNE SDRC
    move.l #$FFFFFFFF,sectwas
    ENDC
    IFNE SDVERER
    move.b d0,d1
    bsr tx_hex * display error code -status of CMD17
    move.l #rcmd17nm,a0
    bsr sdvmsg
    ENDC
    move.w #1,d0 * cannot get data token in 101 iterations, reporting error
    rts

sdrslpe: * now, waiting for data token
    move.w #$80,d4 * it will start with FE
sdrsl1:
    move.w #$7FFF,d5
sdrsl12:
    IFNE SDWDGB
    bsr sdrbdb * will return in D0
    ENDC
    IFEQ SDWDGB
    bsr sdrb * will return in D0
    ENDC
    cmpi.b #$FE,d0
    beq sdrsl1e * got data token
    dbra d5,sdrsl12
    IFNE SDWLONGO
    move.b #'.',d1
    bsr conout
    ENDC
    dbra d4,sdrsl1
    IFNE SDRC
    move.l #$FFFFFFFF,sectwas
    ENDC
    IFNE SDVERER
    move.l #rcmd17nd,a0
    bsr sdvmsg
    ENDC
    move.w #1,d0 * cannot get data token in <s>101</s> fucking huge
*number of iterations, reporting error
    rts

sdrsl1e: * read loop 1 exit

    move.l #sd_sector,a0
    move.w #$201,d4 * #200 bytes of sector data, 2 bytes of CRC -1
sdrsl2:
    bsr sdrb
    move.b d0,(a0)+
    dbra d4,sdrsl2

* bsr sdrbdb
* bsr sdrbdb
* bsr sdrbdb

    clr.w d0 * All good
    rts


* I do not understand why I wrote those PUSHes, but it worked
* IFNE SDVERER
* * d0 should be preserved
*sdvmsg:
* move.b (a0)+,d0 * WHAT IS DID?
* bsr tx_str
* move.l (sp)+,d0 * WHAT IT DID?
* rts
* ENDC

 IFNE SDVERER
* d0 should be preserved
sdvmsg:
 move.l d0,-(sp) *
 bsr tx_str
 move.l #lbaemsg,a0 * 241023
 bsr tx_str *
 move.l lastlba,d0 *
 bsr tx_l *
 move.l #crlf_msg,a0
 bsr tx_str
 move.l (sp)+,d0
 rts
 ENDC

 IFEQ SD_ONOFF
sd_on: move.b #$FB,sd_port
 rts
sd_off: move.b #$FF,sd_port
 rts
 ENDC

hdelay:
  move.l d3,-(sp)
  move.w #$1000,d3
hdela2:
  dbra d3,hdela2
  move.l (sp)+,d3
  rts

**********************************************************
* Init hardware stuff
**********************************************************
hwinit:
    IFNE DUART
* Do not do it if the console on DUART before
* DUART initialized!
* if we care about jumper
 IFNE SWJUMP1
 btst #1,sd_port * 0 if card present
 bne hwinitsk * if absent - skipit
 ENDC
    IFNE CONSAVR
    movea.l #duinistr,a0
    bsr tx_str
    ENDC

    movea.l #DUART,a0
    move.b #$A,DUCRA(a0) *disable RX and TX
    move.b #$A,DUCRB(a0) *disable RX and TX

    move.b #$20,DUCRA(a0) * reset receiver
    move.b #$30,DUCRA(a0) * reset transmitter
    move.b #$40,DUCRA(a0) * reset error status
    move.b #$50,DUCRA(a0) * reset smth else
    move.b #$60,DUCRA(a0) * and even more

    move.b #$20,DUCRB(a0) * reset receiver
    move.b #$30,DUCRB(a0) * reset transmitter
    move.b #$40,DUCRB(a0) * reset error status
    move.b #$50,DUCRB(a0) * reset smth else
    move.b #$60,DUCRB(a0) * more

* Set Interrupt Mask Register ((2*$A) = 0)*
* ISR and IMR
*
*

*order proposed: MR,MODE,BAUDLIST

    move.b #0,DUACR(a0) * clock set 1
    move.b #DUASPEED,DUCSRA(a0) *
    move.b #DUASPEED,DUCSRB(a0) *

    move.b #0,DUOPCR(a0) * all the parralel outputs just outputs
    move.b #3,DUOP(a0) * Lower RTS for both ports

    move.b #$10,DUCRA(a0) * we ll talk to MR1A
    move.b #$93,DUMR1A(a0) * Use RTS (or 13 for no RTS)
    move.b #$17,DUMR2A(a0) * Not 37! Read the docs! (or 7 to ignore cts)

    move.b #$10,DUCRB(a0) * we ll talk to MR1B
    move.b #$93,DUMR1B(a0) * Use RTS (or 13 for no RTS)
    move.b #$17,DUMR2B(a0) * Not 37! Read the docs! (or 7 to ignore cts)


    move.b #$5,DUCRA(a0)
    move.b #$5,DUCRB(a0)
    ENDC

hwinitsk:
 rts

********************************************************************
* My own local functions for debug
* tx string from A0
tx_str:
 move.b (a0)+,d1
 beq txstrex
 move.l a0,-(sp)
 bsr conout
 move.l (sp)+,a0
 bra tx_str
txstrex:
 rts

**********************************************

* Tx byte in D1 (spoils D0)
tx_hex:
    move.b d0,(slowclk) * switching clock slow
    move.b (uartstat),d0 * getting UART TX READY status
    move.b d0,(fastclk) * switching clock fast
    andi.b #$01,d0
    bne tx_hex * not clear to send
    move.b d0,(slowclk) * switching clock slow
    move.b d1,(uartstat) * writing byte TO STATUS REGISTER - thats a HEX output
    move.b d0,(fastclk) * switching clock fast
    rts
* tx_l in D0
tx_l:
    move.l d0,-(sp)
    swap d0
    andi.l #$FFFF,d0
    bsr tx_w
    move.l (sp)+,d0
    andi.l #$FFFF,d0
    bsr tx_w
    rts
*-------------------tx word (hex) , d0
tx_w:
    move.l d1,-(sp)
    move.l d0,-(sp)
* lsr should be here!
    ror #8,d0
    move.b d0,d1
    bsr tx_hex
    move.l (sp)+,d1
    andi.l #$00FF,d1
    bsr tx_hex
    move.l (sp)+,d1
    rts


 IFEQ ASSREC
* data
 ENDC

 IFNE SDSECD
rtmsg:
 dc.b $0D,$0A,'Reading track: ',0
rdwrmsg:
 dc.b $0D,$0A,'Reading track for write: ',0
wtmsg:
 dc.b $0D,$0A,'Writing track: ',0
rtwrok:
 dc.b $0D,$0A,'Track Read OK!',$0D,$0A,0
rsmsg:
 dc.b $0D,$0A,'(skipping read sector)',$0D,$0A,0
 ENDC

 IFNE TOBCS
bcmsg:
 dc.b $0D,$0A,'BIOS CALL:',0
 ENDC

 IFNE DUART
duinistr:
 dc.b '[Initing DUART]',$0D,$0A,0
 ENDC

 IFNE SDVERER
wcnrmsg:
 dc.b $0D,$0A,'W:Cant read sector',0
wcnrems:
 dc.b $0D,$0A,'W:Cant get 0',0
wbnamsg:
 dc.b $0D,$0A,'W:Write was not accepted',0
wdnwmsg:
 dc.b $0D,$0A,'W:Did not write',0
 IFNE USECMD13
*wcmd13nm:
* dc.b $0D,$0A,'W:Cannot cmd13 (byte 1)',0
wcmd13sm:
 dc.b $0D,$0A,'W:Cmd13 status wrong',0
 ENDC
rcmd17nm:
 dc.b $0D,$0A,'R:Cmd17 cannot get 0',0
rcmd17nd:
 dc.b $0D,$0A,'R:Cmd17 cannot get data token',0
lbaemsg:
 dc.b $0D,$0A,'LBA caused error ',0
 ENDC

biosmsg:
 IFNE ASCPLDR
  dc.b $0D,$0A,'DtZ 68kavr Loader BIOS '
  dc.b '0.00.02/2510'
  IFNE SDHC
   dc.b '/SDHC'
  ENDC
 ENDC

 IFEQ ASCPLDR
  IFNE ASSREC
   dc.b $0D,$0A,'DtZ 68kavr SRECORD BIOS '
   dc.b '0.00.02/2510'
   IFNE SDHC
    dc.b '/SDHC'
   ENDC
* dc.b $0D,$0A,0
  ENDC
  IFEQ ASSREC
   dc.b $0D,$0A,'DtZ 68kavr DISK BIOS '
   dc.b '0.00.02/2510'
   IFNE SDHC
    dc.b '/SDHC'
   ENDC
   IFNE MEM256K * 256K
    dc.b '/MEM256K'
   ENDC
   IFEQ MEM256K * 128K
    dc.b '/MEM128K'
   ENDC
  ENDC
 ENDC
 IFNE DUART
     dc.b '/DUART'
 ENDC

 IFNE IOBYTE
 dc.b '/IOBYTE'
 ENDC
 IFNE SWJUMP1
 dc.b '/SWJMP1'
 ENDC
 IFNE USECMD13
  dc.b '/CMD13'
 ENDC
 dc.b $0D,$0A,0


crlf_msg:
 dc.b $0D,$0A,0

seldrv dc.b 0 * selected disk
 even
track dc.w 0
sector dc.w 0
dma dc.l 0
lastlba dc.l 0
 even
memrgn dc.w 1
 dc.l $400
 IFNE ASSREC
 dc.l $14c00 * goes until 15000 in our case?
 ENDC

 IFEQ ASSREC
 IFNE MEM256K * 256K
 dc.l $37c00 * goes until 38000 hex
 ENDC
 IFEQ MEM256K * 128K
 dc.l $17c00 * goes until 18000 hex
 ENDC
 ENDC


 even
 IFNE IOBYTE
iob dc.w 0
 ENDC

 IFNE SDRC
*reading_track_msg_really:
* dc.b '[RRREADING]',0
*reading_track_comparing:
* dc.b $0D,$0A,'Will compare to ',0

*cached_r_msg:
* dc.b 'Cached block',0
 even
sectwas:
 dc.l $FFFFFFFF
 ENDC


*
* Thats all were stollen from Grant Searle Z80 CP/M computer
*

dph0:
* disk 1
  dc.l $0000 * xlt
  dc.w $0000,$0000,$0000 * 3 scratchpad words
  dc.l dirbuf,dpb0,0000,alv00 * dirbuf,dpb,csv,alv

  IFEQ ASCPLDR
* disk 2
  dc.l $0000 * xlt
  dc.w $0000,$0000,$0000
  dc.l dirbuf,dpb,0000,alv01

* disk 3
  dc.l $0000 * xlt
  dc.w $0000,$0000,$0000
  dc.l dirbuf,dpb,0000,alv03
* disk 4
  dc.l $0000 * xlt
  dc.w $0000,$0000,$0000
  dc.l dirbuf,dpb,0000,alv04
* disk 5
  dc.l $0000 * xlt
  dc.w $0000,$0000,$0000
  dc.l dirbuf,dpb,0000,alv05
* disk 6
  dc.l $0000 * xlt
  dc.w $0000,$0000,$0000
  dc.l dirbuf,dpb,0000,alv06
* disk 7
  dc.l $0000 * xlt
  dc.w $0000,$0000,$0000
  dc.l dirbuf,dpb,0000,alv07
* disk 8
  dc.l $0000 * xlt
  dc.w $0000,$0000,$0000
  dc.l dirbuf,dpb,0000,alv08
* disk 9
  dc.l $0000 * xlt
  dc.w $0000,$0000,$0000
  dc.l dirbuf,dpb,0000,alv09
* disk 10
  dc.l $0000 * xlt
  dc.w $0000,$0000,$0000
  dc.l dirbuf,dpb,0000,alv10
* disk 11
  dc.l $0000 * xlt
  dc.w $0000,$0000,$0000
  dc.l dirbuf,dpb,0000,alv11
* disk 12
  dc.l $0000 * xlt
  dc.w $0000,$0000,$0000
  dc.l dirbuf,dpb,0000,alv12
* disk 13
  dc.l $0000 * xlt
  dc.w $0000,$0000,$0000
  dc.l dirbuf,dpb,0000,alv13
* disk 14
  dc.l $0000 * xlt
  dc.w $0000,$0000,$0000
  dc.l dirbuf,dpb,0000,alv14
* disk 15
  dc.l $0000 * xlt
  dc.w $0000,$0000,$0000
  dc.l dirbuf,dpbLast,0000,alv15
  ENDC

* First drive has a reserved track for CP/M
dpb0:
                dc.w 128 *SPT - sectors per track
                dc.b 5 *BSH - block shift factor
                dc.b 31 *BLM - block mask
                dc.b 1 *EXM - Extent mask
  dc.b 0 * ** NEW for cp/m 68
                dc.w 2043 *DSM (2047-4) dc.wM - Storage size (blocks - 1)
                dc.w 511 *DRM - Number of directory entries - 1
  dc.w 0 * reserved
* dc.b 240 *AL0 - 1 bit set per directory block
* dc.b 0 *AL1 - ""
                dc.w 0 *CKS - DIR check vector size (DRM+1)/4 (0=fixed disk)
                dc.w 1 *OFF - Reserved tracks


  IFEQ ASCPLDR

dpb:
                dc.w 128 *SPT - sectors per track
                dc.b 5 *BSH - block shift factor
                dc.b 31 *BLM - block mask
                dc.b 1 *EXM - Extent mask
  dc.b 0 * ** NEW for cp/m 68
                dc.w 2047 *dc.wM - Storage size (blocks - 1)
                dc.w 511 *DRM - Number of directory entries - 1
  dc.w 0 * reserved
* dc.b 240 *AL0 - 1 bit set per directory block
* dc.b 0 *AL1 - ""
                dc.w 0 *CKS - DIR check vector size (DRM+1)/4 (0=fixed disk)
                dc.w 0 *OFF - Reserved tracks

* Last drive is smaller because CF is never full 64MB or 128MB
dpbLast:
                dc.w 128 *SPT - sectors per track
                dc.b 5 *BSH - block shift factor
                dc.b 31 *BLM - block mask
                dc.b 1 *EXM - Extent mask
  dc.b 0 * ** NEW for cp/m 68
                dc.w 511 *dc.wM - Storage size (blocks - 1) * 511 = 2MB (for 128MB card), 1279 = 5MB (for 64MB card)
                dc.w 511 *DRM - Number of directory entries - 1
  dc.w 0 * reserved
* dc.b 240 *AL0 - 1 bit set per directory block
* dc.b 0 *AL1 - ""
                dc.w 0 *CKS - DIR check vector size (DRM+1)/4 (0=fixed disk)
                dc.w 0 *OFF - Reserved tracks
  ENDC

dirbuf: ds.b 128 *scratch directory area
alv00: ds.b 257 *allocation vector 0
  IFEQ ASCPLDR
alv01: ds.b 257 *allocation vector 1
alv02: ds.b 257 *allocation vector 2
alv03: ds.b 257 *allocation vector 3
alv04: ds.b 257 *allocation vector 4
alv05: ds.b 257 *allocation vector 5
alv06: ds.b 257 *allocation vector 6
alv07: ds.b 257 *allocation vector 7
alv08: ds.b 257 *allocation vector 8
alv09: ds.b 257 *allocation vector 9
alv10: ds.b 257 *allocation vector 10
alv11: ds.b 257 *allocation vector 11
alv12: ds.b 257 *allocation vector 12
alv13: ds.b 257 *allocation vector 13
alv14: ds.b 257 *allocation vector 14
alv15: ds.b 257 *allocation vector 15
  ENDC


sd_sector:
* if we assemble as SRecord, we do not need this 514 bytes in Srecord
 IFEQ ASSREC
 ds.b $202
 ENDC
sd_secte:
* here should be at least $202 bytes
 END

