#!/usr/local/bin/tclsh
#
# Script to check defs.h is correct. It checks for duplicate defines.
#


set fd [open "defs.h" r]
set f [read $fd [file size "defs.h"]]
close $fd

set d1 [set d2 [list]]
foreach line [split $f "\n"] {
 if {$line == ""} continue
 foreach {define what iswhat} [split $line " "]  break
 if {[lsearch $d1 $what] != -1} {
  puts "Duplicate key: $what ($line)"
 }
 if {[lsearch $d2 $iswhat] != -1} {
  puts "Duplicate value: $iswhat ($line)"
 }
 lappend d1 $what
 lappend d2 $iswhat
}
