;
; Boot file without attempt of command chaining
;
;
;0azA    data
stackpointer equ $1FFE
;stackpointer equ $1FFFC
     dc.l stackpointer
     dc.l start
;    code
    include "vectors.asm"

CR	equ	$0D
LF	equ	$0A
BACKSPACE_KEY	equ	$7F
BACKSPACE	equ	8
SPACE	equ	$20
CTRLC	equ	3
    
    include	"byteio_fast.asm"
;    include	"byteio_avr.asm"
; Start point - same as warm, bit outputs (c) message. Stack pointer
; assumed to be inited from (0)

start:
    movea.l	#stackpointer,sp
    move.b	d0,($E0000) ; switching clock fast
    lea.l	hellomsg,a0
    bsr	tx_str
    bsr	warm
; interrupt happened
INT:
    movea.l	#stackpointer,sp
    move.b	d0,($E0000) ; switching clock fast
    lea.l	intmsg,a0
    bsr	tx_str
    bsr	warm

; Software interrupt happened
INT_s:
    movea.l	#stackpointer,sp
    move.b	d0,($E0000) ; switching clock fast
    lea.l	int_s_msg,a0
    bsr	tx_str
    bsr	warm

; Software interrupt happened
INT_s0:
    movea.l	#stackpointer,sp
    move.b	d0,($E0000) ; switching clock fast
    lea.l	int_s0_msg,a0
    bsr	tx_str
    bsr	warm
; Software interrupt happened
INT_s1:
    movea.l	#stackpointer,sp
    move.b	d0,($E0000) ; switching clock fast
    lea.l	int_s1_msg,a0
    bsr	tx_str
    bsr	warm
; Software interrupt happened
INT_s2:
    movea.l	#stackpointer,sp
    move.b	d0,($E0000) ; switching clock fast
    lea.l	int_s2_msg,a0
    bsr	tx_str
    bsr	warm
; Software interrupt happened
INT_s3:
    movea.l	#stackpointer,sp
    move.b	d0,($E0000) ; switching clock fast
    lea.l	int_s3_msg,a0
    bsr	tx_str
    bsr	warm
; Software interrupt happened
INT_s4:
    movea.l	#stackpointer,sp
    move.b	d0,($E0000) ; switching clock fast
    lea.l	int_s4_msg,a0
    bsr	tx_str
    bsr	warm
; Software interrupt happened
INT_s5:
    movea.l	#stackpointer,sp
    move.b	d0,($E0000) ; switching clock fast
    lea.l	int_s5_msg,a0
    bsr	tx_str
    bsr	warm
; Software interrupt happened
INT_s6:
    movea.l	#stackpointer,sp
    move.b	d0,($E0000) ; switching clock fast
    lea.l	int_s6_msg,a0
    bsr	tx_str
    bsr	warm
; Software interrupt happened
INT_s7:
    movea.l	#stackpointer,sp
    move.b	d0,($E0000) ; switching clock fast
    lea.l	int_s7_msg,a0
    bsr	tx_str
    bsr	warm
; Software interrupt happened
INT_s8:
    movea.l	#stackpointer,sp
    move.b	d0,($E0000) ; switching clock fast
    lea.l	int_s8_msg,a0
    bsr	tx_str
    bsr	warm
; Software interrupt happened
INT_s9:
    movea.l	#stackpointer,sp
    move.b	d0,($E0000) ; switching clock fast
    lea.l	int_s9_msg,a0
    bsr	tx_str
    bsr	warm
; Software interrupt happened
INT_sa:
    movea.l	#stackpointer,sp
    move.b	d0,($E0000) ; switching clock fast
    lea.l	int_sa_msg,a0
    bsr	tx_str
    bsr	warm
; Software interrupt happened
INT_sb:
    movea.l	#stackpointer,sp
    move.b	d0,($E0000) ; switching clock fast
    lea.l	int_sb_msg,a0
    bsr	tx_str
    bsr	warm
; Software interrupt happened
INT_sc:
    movea.l	#stackpointer,sp
    move.b	d0,($E0000) ; switching clock fast
    lea.l	int_sc_msg,a0
    bsr	tx_str
    bsr	warm


INT_priv:
    movea.l	#stackpointer,sp
    move.b	d0,($E0000) ; switching clock fast
    lea.l	int_priv_msg,a0
    bsr	tx_str
    bsr	warm

INT_addr:
    movea.l	#stackpointer,sp
    move.b	d0,($E0000) ; switching clock fast
    lea.l	int_addr_msg,a0
    bsr	tx_str
    bsr	warm

INT_illin:
    movea.l	#stackpointer,sp
    move.b	d0,($E0000) ; switching clock fast
    lea.l	int_ill_msg,a0
    bsr	tx_str
    bsr	warm


; warm start. bra here to return.
warm:
    movea.l	#stackpointer,sp
; installing trap 15 handler
    move.l	#trap_tx_char,$BC

loop2:

    movea.l	#promptmsg,a0 ;outputting prompt
    bsr	tx_str
    movea.l	#buff,a0 ; getting string
    move.w	#100,d0  ; to buff , size 10
    bsr	rx_str
    movea.l	#buff,a0 ; is string empty?
    move.b	(a0),d0
    beq	loop2

;    movea.l	#buff,a0
;    bsr	tx_str
    bsr	cmdexecute  	; try to decode command

    bra	loop2


; Compare buffer to a known command
cmdexecute:
    movea.l	#commands,a0	; loading the dictionary into A0
    movea.l	#commands_vector,a4 ; loading the vector pointer
cmdexecuteloop:
    movea.l	#buff,a1	; for every next command in dictionary, compare with the start of buffer
    cmpi.b	#$0,(a0)	; Commands ended?
    bne	cmdexecnextcmd	; check for next command
    movea.l	#errmsg,a0	; Yes, no more commands ; unknown command message
    bsr		tx_str
    movea.l	#buff,a0	; .. and the buffer itself
    bsr	tx_str
;   move.b	d0,($C0000)
    rts

cmdexecnextcmd:
    movea.l	a0,a3	; saving pointer to the currenly examined command

cmdexecloop2:
    move.b	(a0)+,d0	; take current char from command from the commands table
    beq	cmdexecdo		; the command ended - and if it was equal to buffer - executing it
    move.b	(a1)+,d1
    cmp.b	#$7a,d1	;'z'
    bgt		cmdexecnotuppercase
    cmp.b	#$61,d1	;'a'
    blt.b	cmdexecnotuppercase
    subi.b	#$20,d1		; uppercasing
cmdexecnotuppercase:
    cmp.b	d1,d0
; WAS    cmp.b	(a1)+,d0	; repat until buffer and command are equal
    beq	cmdexecloop2
				; if we got here, the command is not equal to buffer
cmdrewindtoendofcommand:	; rewinding command dictionary to the end of command
    cmpi.b	#$0,(a0)+
    bne	cmdrewindtoendofcommand

    adda.w	#$4,a4		; incrementing pointer to a function
    bra	cmdexecuteloop		; try to compare with next command

cmdexecdo:
;    movea.l	#executing_msg,a0
    ;bsr	tx_str

    movea.l	#crlfmsg,a0
    bsr	tx_str

;    movea.l	a3,a0		; a3 points to the dictionary - start of command
;    bsr	tx_str

;    move.b	d0,($E0000)
;    move.l	a4,-(sp)	; a4 is calculated subrotine address
;
;    move.l	(a4),d0
;    bsr	tx_l
    move.l	(a4),a0		; and a1 is pointing to the end of the buffer (after command)
    jmp.l	(a0)
;    move.l	a4,-(sp)	; a4 is calculated subrotine address
    rts				; jumps there - it should  rts to main loop
;    rts

;    move.w	(a4),d0
;    bsr	tx_w
;    adda	#$2,a4
;    move.w	(a4),d0
;    bsr	tx_w
;    rts
    

;------------------------ Commands----------------------------------

fuckaduck:	; a1 points to the buffer after the command
    move.l	#quackmsg,a0
    bsr	tx_str
    move.l	a1,a0
    bsr	scan_b
;    bsr	tx_l
;    move.b	d1,d1 ; set flag - whats the correct way?
    move.l	a0,a1	; a0 is a pointer to end of buffer

    cmpi	#$0,d1
    beq	fuckaduckok
    bsr	tx_b	; that is a scanned word in A0
    move.b	d1,d0
    bsr	tx_b	; that is a 2-number of scanned nibbles
    move.l	#quackerrmsg,a0 ; it's a error
    bsr	tx_str
    move.l	a1,a0	; a1 still holds pointer to input buffer string
    bsr	tx_str
    rts
fuckaduckok:	; ok, we've got a byte
    bsr	tx_b
    rts

f_go:
    move.l	a1,a0
    bsr	scan_l
    move.l	d0,a0
    jmp.l	(a0)

;f_s:
    include	"f_srecord.asm"

f_0:	
    move.b	#$0,($80000)
    rts
f_1:	
    move.b	#$1,($80000)
    rts
f_2:	
    move.b	#$2,($80000)
    rts
f_4:	
    move.b	#$4,($80000)
    rts
    
f_blink:
    move.b	#$ff,($80000)

    move.l	#$10000,d1
f_blink1:
    subi.l	#1,d1
    bne		f_blink1

    move.b	#$00,($80000)

    move.l	#$10000,d1
f_blink2:
    subi.l	#1,d1
    bne		f_blink2

    bsr	rx_notempt
    beq	f_blink
    bsr	rx_char
    rts

f_ledon:
    move.b	#$ff,($80000)
    rts

f_ledoff:
    move.b	#$00,($80000)
    rts

f_in:
    move.b	($80000),d0
    andi.b	#$01,d0
    addi.b	#'0',d0
    bsr	tx_char
    rts

; blink fast
f_bf:
    move.b	d0,($E0000)
    move.w	#$800,d0
f_bf0:
    move.b	#$80,d1
f_bf1:
    move.b	d1,($20000)
    subi.b	#1,d1
    bne		f_bf1

    move.b	#$80,d1
f_bf2:
    subi.b	#1,d1
    bne		f_bf2
    
    subi.w	#$1,d0
    bne		f_bf0
    move.b	d0,($C0000)
    rts

; blink slowly ; 8000 times
f_bs:
    move.w	#$100,d0
f_bs0:
    move.b	#$80,d1
f_bs1:
    move.b	d1,($20000)
    subi.b	#1,d1
    bne		f_bs1

    move.b	#$80,d1
f_bs2:
    subi.b	#1,d1
    bne		f_bs2
    
    subi.w	#$1,d0
    bne		f_bs0
    rts


; dump
; take the address from command line, or from dumpstart
f_dump:
    move.b	(a1),d0 ; any address specified?
    beq	f_dump_default_addr

    move.l	a1,a0
    bsr	scan_hex_string	; d0 holds the start of dump
    bra	f_dump_got_addr

f_dump_default_addr:
    move.l	(dumpstart),d0

f_dump_got_addr: ; a1 is address to start dump
    move.l	d0,a1
    move.b	#$10,d2 ; $10 lines

f_dump_loop_0:
    movea.l	#crlfmsg,a0
    bsr	tx_str
    move.l	a1,d0	; showing address we dump from
    bsr	tx_l	
    move.b	#$20,d0
    bsr	tx_char
    move.b	#$10,d1 ; $10 lines
    movea.l	#f_dump_buf,a3
;    move.l	a1,a0
f_dump_loop_1:
    move.b	(a1)+,d0
    bsr	tx_b
    cmpi.b	#$20,d0
    bgt		f_dump_loop_1a ; is byte printable?
    move.b	#'.',d0
f_dump_loop_1a:
    move.b	d0,(a3)+
    move.b	#$20,d0
    bsr	tx_char
    subi.b	#$1,d1
    bne	f_dump_loop_1  ; showing line loop - done
    movea.l	#f_dump_buf_min_1,a0
    bsr	tx_str		; showing line as ascii
    subi.b	#$1,d2
    bne	f_dump_loop_0 ; next line

    move.l	a1,d0
    move.l	d0,(dumpstart) ; saving address
    rts
f_dump_buf_min_1:
    dc.b ' '
f_dump_buf:
    dc.b '0123456789abcdef',0

    even

    include	"f_boot.asm"

; input: a0
; output:
; d1 = 1 - not a hex char
; d1 = 0 - is a hex char
;  d0 - 0-f if scanned

char_is_hex:
    andi.l	#$ff,d0
    cmpi.b	#$30,d0
    blt	char_is_hex_no
    cmpi.b	#$40,d0
    ble	char_is_hex_1	; 30-40 - '0'-'9'
    andi.b	#$df,d0	; it it's a lowercase - map to uppercase
    cmpi.b	#$41,d0 ; less then 'A'?
    blt	char_is_hex_no
    cmpi.b	#$46,d0	; more then 'F'?
    bgt	char_is_hex_no
    subi.b	#55,d0	; yes, 55 dec
    bra 	char_is_hex_yes

char_is_hex_1:
    subi.b	#$30,d0
    bra 	char_is_hex_yes

char_is_hex_yes
    move.b	#0,d1
    rts
    
char_is_hex_no:
    move.b	#1,d1
    rts






; input A0 - pointer to string
; output D0 - hex (up to long)

scan_hex_string:
    move.l	d1,-(sp)
    move.b	#$FF,d1
    bsr	scan_hex_seq
    move.l	(sp)+,d1
    rts

; input byte
; return byte int d0, error in d1
scan_b:
    move.b	#$2,d1
    bra	scan_hex_seq

; input word
; return word in d0, error in d1
scan_w:
    move.b	#$4,d1
    bra	scan_hex_seq

; input word
; return 24bit in d0, error in d1
scan_24bit:
    move.b	#$6,d1
    bra	scan_hex_seq

; input long
; return long in d0, error in d1
scan_l:
    move.b	#$8,d1
    bra	scan_hex_seq




; input A0 - pointer to string
; d1 - nibbles to scan ; 0 for scan long strings as hex
;
; output D0 - hex (up to long)
; d1 - 0, if no error; 1, if is a error
; A0 points to the first non-hex char, if error occured
;  or point to next char if ok
scan_hex_seq:
    move.l	d2,-(sp)	; saving d2
    move.l	#0,d2	; the resulting byte/word/longword
    addi.b	#$1,d1	; in loop we first decrement, then check, then do; so we compensate
scan_hex_string_1:
    subi.b	#$1,d1
    beq	scan_hex_string_end
    move.l	d1,-(sp)	; pushing counter

    move.b	(a0)+,d0	; taking next byte from the string
    bsr 	char_is_hex	; spoils d1, that is why we pushed d1
;    cmpi.b	#0,d1
    bne	scan_hex_string_end_not_ok
    lsl.l	#4,d2
    add.l	d0,d2
    move.l	(sp)+,d1	; popping counter
    bra 	scan_hex_string_1

scan_hex_string_end_not_ok:
    move.l	(sp)+,d1	; popping counter
;    move.b	#$1,d1	; whatever happened, set error ; cointer is not 0, anyway
    suba.l	#$1,a0	; Error happened, it means that we point to char next to first non-hex. Amh. Like that.
scan_hex_string_end:	; normal termination
    move.l	d2,d0
    move.l	(sp)+,d2	; popping d2
    rts




;------------------ RX str int A0; length in word D0
rx_str:
    move.b	#$0,(a0)
    move.w	#$0,d1	; current char pointer
    move.w	d0,d2
rx_str_loop:
    bsr	rx_char
;    move.b	d0,(uartstat)
    cmp.b	#CR,d0
    beq	rx_str_exit
    cmp.b	#LF,d0
    beq	rx_str_exit
    cmp.b	#BACKSPACE_KEY,d0
    beq	rx_str_bs
    cmp.b	#SPACE,d0	;got not printable char
    blt	rx_str_loop


    bsr	tx_char		; regular char
    move.b	d0,(a0)+	;storing next character to a0
    move.b	#$0,(a0) ; writing eostring to a0
    addi	#$1,d1 ; incrementing current char pointer
;    move.b	d1,(uartstat)
;   move.b	d2,(uartstat)

    cmp.w	d1,d2 ; full?
    bne	rx_str_loop ; go again

rx_str_exit:
    move.b	#$0,(a0)
;    movea.l	#crlfmsg,a0
;    bsr	tx_str
    rts
rx_str_bs:
    move.w	d1,d1	;set Z flag is a0 is not 0
    beq	rx_str_loop
    move.b	#$0,-(a0)
    subi.b	#$1,d1
    move.b	#BACKSPACE,d0
    bsr	tx_char		; should output backspace char
    move.b	#SPACE,d0
    bsr	tx_char
    move.b	#BACKSPACE,d0
    bsr	tx_char
    bra	rx_str_loop



;-------------------tx longword 
tx_l:
    move.l	d0,-(sp)
    swap	d0
    andi.l	#$FFFF,d0
    bsr	tx_w
    move.l	(sp)+,d0
    andi.l	#$FFFF,d0
    bsr	tx_w
    rts

;-------------------tx word (hex)
tx_w:
    move.l	d0,-(sp)
; lsr should be here!
    ror	#8,d0
    bsr	tx_b
    move.l	(sp)+,d0
    andi.l	#$00FF,d0
    bsr	tx_b
    rts

;-------------------tx byte (hex)
tx_b:
    move.l	d0,-(sp) ; we need it twice
    move.l	d0,-(sp)
    andi.l	#$00F0,d0
; lsr should be here
    ror	#4,d0
    addi.b	#48,d0	; adding '0'
    cmpi.b	#57,d0
    ble	tx_byte_1	; branch if less then 0xA
    addi.b	#7,d0	; 59->65,'A'
tx_byte_1:
    bsr	tx_char
    move.l	(sp)+,d0
    andi.l	#$000F,d0
    addi.b	#48,d0	; adding '0'
    cmpi.b	#57,d0
    ble	tx_byte_2	; branch if less then 0xA
    addi.b	#7,d0	; 59->65,'A'
tx_byte_2:
    bsr	tx_char
    move.l	(sp)+,d0
    rts

;------------------ TX str in A0 ; destroys A0
tx_str:
    move.l	d0,-(sp)
tx_str_loop:
    move.b	(a0)+,d0
    cmpi.b	#$0,d0
    beq	tx_str_exit
    bsr	tx_char
    bra	tx_str_loop
tx_str_exit:
    move.l	(sp)+,d0
    rts

;-------------------------------- Strings -------------------------
;    data
    even
    cnop	$,2
commands_vector:
    dc.l	f_dump
    dc.l	f_go
    dc.l	f_blink
    dc.l	f_bs
    dc.l	f_bf
    dc.l	f_ledon
    dc.l	f_ledoff
    dc.l	f_in
    dc.l	f_0
    dc.l	f_1
    dc.l	f_2
    dc.l	f_4
    dc.l	f_boot
    dc.l	f_s
    dc.l	fuckaduck

    even

commands:
    dc.b	'DUMP',0
    dc.b	'GO',0
    dc.b	'BLINK',0
    dc.b	'BS',0
    dc.b	'BF',0
    dc.b	'ON',0
    dc.b	'OFF',0
    dc.b	'IN',0
    dc.b	'0',0
    dc.b	'1',0
    dc.b	'2',0
    dc.b	'4',0
    dc.b	'BOOT',0
    dc.b	'S',0	; S-record parcer
    dc.b	'FUCK A DUCK',0
;    dc.l	#fuckaduck
    dc.b	0

; 'DUMP' command will resume from this address
    even
dumpstart:
    dc.l	0

crlfmsg:
    dc.b	CR,LF,0

errmsg:
    dc.b	CR,LF
    dc.b	'? err: '
    dc.b	0

intmsg:
    dc.b	'Interrupt happened!',CR,LF,0
int_s_msg:
    dc.b	'Interrupt happened - software int!',CR,LF,0

int_s0_msg:
    dc.b	'INT0!',CR,LF,0
int_s1_msg:
    dc.b	'INT1!',CR,LF,0
int_s2_msg:
    dc.b	'INT2!',CR,LF,0
int_s3_msg:
    dc.b	'INT3!',CR,LF,0
int_s4_msg:
    dc.b	'INT4!',CR,LF,0
int_s5_msg:
    dc.b	'INT5!',CR,LF,0
int_s6_msg:
    dc.b	'INT6!',CR,LF,0
int_s7_msg:
    dc.b	'INT7!',CR,LF,0
int_s8_msg:
    dc.b	'INT8!',CR,LF,0
int_s9_msg:
    dc.b	'INT9!',CR,LF,0
int_sa_msg:
    dc.b	'INTa!',CR,LF,0
int_sb_msg:
    dc.b	'INTb!',CR,LF,0
int_sc_msg:
    dc.b	'INTc!',CR,LF,0

int_priv_msg:
    dc.b	'Interrupt happened - Privelege violation',CR,LF,0
int_ill_msg:
    dc.b	'Interrupt happened - illegal instruction',CR,LF,0
int_addr_msg:
    dc.b	'Interrupt happened - address violation',CR,LF,0
hellomsg:
    dc.b	'DtZ '
    dc.b	'68kavrB '
    include	"../version.asm"
    dc.b	CR,LF,0

;    align 4
promptmsg:
    dc.b	CR,LF
    dc.b	'*'
    dc.b	0

quackmsg:
    dc.b	CR,LF
    dc.b	'>0',CR,LF,' ( )<',$0d,$0a,' _|','   '
    dc.b	'QUACK '
    dc.b	'QUACK '
    dc.b	'QUACK '
    dc.b	0

quackerrmsg:
    dc.b	'FUCK ->',0

executing_msg:
    dc.b	CR,LF
    dc.b	'Doing ',0
;    align 4
buff:
    ds.b	100

;    dc.b	'_______'
;    dc.b	'_______'
;    dc.b	0
;    align 4



;    ds.b	8
;    ds.b	8
;    ds.b	8
;    ds.b	8



