;
; Procs for fast (freq switching) Char IO
;
; Here, highest nibble is not decoded
; and not significant
;
uartstat equ $FF7A0002
uartdata equ $FF7A0000
;
; FASTCLK is defined in boot.asm
; so SLOWCLK
;slowclock equ	$FFFC0000
;fastclock equ	$FFFE0000

;------------------ RX char
rx_char:
    bsr	rx_notempt	; while not empty
    beq	rx_char		; loop
    move.b	d0,(SLOWCLK) ; switching clock slow
    move.b	(uartdata),d0	; read from uart
    move.b	d0,(FASTCLK) ; switching clock fast
    cmpi.b	#CTRLC,d0	; CTRL-C? 
    beq	warm	; warm reset
    rts

;------------------ Test input for a char (NOT ZERO if IS)
rx_notempt:
    move.b	d0,(SLOWCLK) ; switching clock slow
    move.b	(uartstat),d0
    move.b	d0,(FASTCLK) ; switching clock fast
    andi.b	#$02,d0 ; bit 1 is 1?
    rts

;------------------ Wait for clear to send -------
tx_rdy_w:
    move.l      d0,-(sp)
tx_rdy_w1:
    bsr tx_rdy
    bne tx_rdy_w1
    move.l      (sp)+,d0
    rts

;------------------ TX char - trap
trap_tx_char:
    bsr	tx_char
    rte

;------------------ TX char
tx_char:
    bsr	tx_rdy_w
    move.b	d0,(SLOWCLK) ; switching clock slow
    move.b	d0,(uartdata)
    move.b	d0,(FASTCLK) ; switching clock fast
    rts

;----------------- Returns TX ready (Z)
tx_rdy:
    move.b	d0,(SLOWCLK) ; switching clock slow
    move.b	(uartstat),d0
    move.b	d0,(FASTCLK) ; switching clock fast
    andi.b	#$01,d0
    rts

