7;
;
; Highest nibble is not decoded and not significant
;
sd_port	equ	$FF780000

boot_to	equ	$8000
;SD_CMD0	equ	$02	; Go idle
SD_CMD0	equ	$40	; Go idle
SD_CMD1	equ	$41	; SEND_OP_COND (MMC) Activates card's init process
SD_CMD8	equ	$48	; 
SD_CMD10	equ	$4a	; 
SD_CMD16	equ	$50	; Set block length
SD_CMD17	equ	$51	; Read sector
SD_CMD55	equ	$77	; ACMD prefix
SD_CMD41	equ	$69
SD_CMD58	equ	$7a

BLOCKSIZE_H	equ	$02	; Means SD block size is 512
BLOCKSIZE_L	equ	$00	;
BLOCKSIZE	equ 	$200

    IFNE	DTZSDDEBUG
f_boot_dbg:
  move.b	#0,f_boot_quiet
  bra	f_boot_common
    ENDC
f_boot:
    IFNE	DTZSDDEBUG
  move.b	#1,f_boot_quiet
    ENDC

;
;f_boot_load - that what we should call when just booting, without init,
; if we are doing BOOT and INIT as two different functions

f_boot_common:
  movea.l	#f_boot_msg,a0	; saying "we are booting"
  bsr	tx_str
  bsr	sd_cs_high	; sending $80 (need just 80) ticks when CS high
  move.w		#80,d1
  bsr	sd_send_ticks_cs_high
  
  bsr	sd_cs_low

  move.b	#$FF,d1	; drop this
  bsr 	sd_write_byte
  move.b	#$FF,d1
  bsr 	sd_write_byte
  move.b	#$FF,d1
  bsr 	sd_write_byte
  move.b	#$FF,d1
  bsr 	sd_write_byte

  
; sending CMD0
  move.w	#10,d4	; several times
f_boot_cmd0_toploop:
  move.w	d4,-(sp)
  move.b		#SD_CMD0,d1
  bsr	sd_write_cmd
  movea.l	#f_boot_cmd0_done_msg,a0	; telling about that
  bsr	tx_str

; waiting for 01 response for $10 times
  move.w		#$FFFF,d4 ; change to smth reasonable, pls!
f_boot_cmd0_loop:
  bsr	sd_read_byte
  cmpi.b		#$01,d0	; waiting for 01 
  beq	f_boot_cmd0_got_resp	; ok, got it
  dbra	d4,f_boot_cmd0_loop	; retrying

  move.w	(sp)+,d4
  dbra	d4,f_boot_cmd0_toploop

  movea.l	#f_boot_cmd0_no_resp_msg,a0	; oh no - failed
  bsr	tx_str	; telling that and exiting
  move.b	#$1,d0	; indicating error
  rts	; failed

f_boot_cmd0_got_resp:
  move.w	(sp)+,d4	; taking f_boot_cmd0_toploop counter out of stack

  move.b        f_boot_quiet,d1
  bne	f_boot_cmd0_got_resp_skp
  movea.l	#f_boot_cmd0_resp_msg,a0	
; saying we've got CMD0 response "Cmd0 got 01"
  bsr	tx_str
f_boot_cmd0_got_resp_skp:

  move.b	#$FF,d1	; drop this
  bsr 	sd_write_byte
  move.b	#$FF,d1
  bsr 	sd_write_byte
  move.b	#$FF,d1
  bsr 	sd_write_byte
  move.b	#$FF,d1
  bsr 	sd_write_byte

; lets try to send CMD8
;  bra	f_boot_cmd1
  
  move.b	#SD_CMD8,d1
  move.b	#$87,d6	; CMD8 requires correct checksumm; 87 is precalc
  move.b	#$01,d4
  move.b	#$AA,d5 ; 1 is 2.7-3.6V, AA is thing to echo.
  move.b	#$0,d3
  move.b	d3,d2 
  bsr	sd_write_cmd_with_args_and_checksumm_and_get_result

  IFNE  DTZSDDEBUG
  move.b        f_boot_quiet,d1
  bne	f_boot_cmd0_got_resp_skp_msg
  move.w	d0,-(sp)	; storing what it returned
  bsr	tx_b
  move.b	#'<',d0
  bsr	tx_char
  move.w	(sp)+,d0
f_boot_cmd0_got_resp_skp_msg:
  ENDC


  cmpi.b		#$05,d0	; 
  beq	f_boot_cmd8_ununderstood	; Returned real error

  cmpi.b	#$FF,d0	; Returned nothing at all
  bne	f_boot_cmd8_returned

  movea.l	#f_boot_cmd8_noreply_msg,a0
  bsr	tx_str
  bra	f_boot_cmd1

f_boot_cmd8_returned:
  move.w	d0,-(sp)	; storing what it returned
  movea.l	#f_boot_cmd8_resp_msg,a0
  bsr	tx_str
  move.w	(sp)+,d0
  bsr	tx_b	; hex out
  andi.b	#$FE,d0
  bne	f_boot_cmd1	; we've got 01 or 00 reply -> means CMD8 is ok
 ; 01 is expected, because card should stay in idle mode
  movea.l	#f_boot_cmd8_ok_msg,a0
  bsr	tx_str
;  moveq.l	#0,d6
  clr.l	d6
  bsr	sd_read_byte	; reading R7 response
  add	d0,d6
  lsl	#8,d6
  IFNE  DTZSDDEBUG
  bsr	tx_b
  ENDC
  bsr	sd_read_byte
  add	d0,d6
  lsl	#8,d6
  IFNE  DTZSDDEBUG
  bsr	tx_b
  ENDC
  bsr	sd_read_byte
  add	d0,d6
  lsl	#8,d6
  IFNE  DTZSDDEBUG
  bsr	tx_b			; that two bytes should be checked for 1
  ENDC
  bsr	sd_read_byte
  add	d0,d6
  IFNE  DTZSDDEBUG
  bsr	tx_b			; and AA
  ENDC
  move.b	f_boot_quiet,d1
  bne	f_boot_cmd8_skp_msg
  move.l  d6,d0
  bsr	tx_l
  movea.l	#f_boot_cmd8_ok_msg,a0
  bsr	tx_str	; this is normal place where CMD8 should go
f_boot_cmd8_skp_msg:
  cmpi.w	#$1AA,d6
  beq	f_boot_cmd8_is_v2
  move.l	#f_boot_cmd8_notv2_msg,a0
  bsr	tx_str
  bra	f_boot_cmd1 ; card is not V2, 
f_boot_cmd8_is_v2:
  move.l	#f_boot_cmd8_isv2_msg,a0
  bsr	tx_str	; card is V2

;  bra f_boot_cmd1
 
; sending ACMD 41, waiting for 0 which shows left idle mode
  move.w	#$40,d4

f_boot_acmd41_loop:
  move.w	d4,-(sp)
  move.b	#SD_CMD55,d1	; so sending CMD1
  bsr	sd_write_cmd_and_get_result
  bsr	tx_b
  move.b	#SD_CMD41,d1
  move.b	#$40,d2	; bit 30 set, right?
  move.b	#0,d3
  move.b	d3,d4
  move.b	d4,d5
  bsr	sd_write_cmd_with_args_and_get_result
 ; move.w	d0,-(sp)
  bsr	tx_b
 ; move.b	#':',d0
 ; bsr	tx_char
 ; move.w	(sp)+,d0
  move.w	(sp)+,d4
  cmpi.b	#$0,d0
  beq	f_boot_cmd41_done
;  move.w	(sp)+,d4

  bsr	sd_cs_high	; 
  move.b		#$FF,d1 ;
  bsr	sd_write_byte	;
  bsr	sd_cs_low	; 
;  bsr	significant_delay
  dbra	d4,f_boot_acmd41_loop	; retrying
  move.l	#f_boot_acmd41_msg_failed,a0
  bsr	tx_str	; cannot switch from IDLE mode by ACMD41
  bra	f_boot_cmd1	; that should not happen, but let's retry with CMD1
  
f_boot_cmd41_done:
;  move.w	(sp)+,d4	; popping from stack
  move.l	#f_boot_acmd41_msg_ok,a0
  bsr	tx_str	; 
;  bra	f_boot_cmd16
  bra	f_boot_cmd10 ;
 

f_boot_cmd8_ununderstood:
  movea.l	#f_boot_cmd8_ununderstood_msg,a0
  bsr	tx_str
  
; so sending CMD1s till we get 00 (not 01!)
f_boot_cmd1:
  move.w		#$100,d4
f_boot_cmd1_loop:
  move.w		d4,-(sp)
  move.b	#SD_CMD1,d1	; so sending CMD1
  bsr	sd_write_cmd_and_get_result
  move.w	(sp)+,d4
  cmpi.b		#$00,d0	; waiting for 00 
  beq	f_boot_cmd1_got_resp	; ok, got it
;  bsr	significant_delay
  dbra	d4,f_boot_cmd1_loop	; retrying
  movea.l	#f_boot_cmd1_no_resp_msg,a0	; oh no - failed
  bsr	tx_str	; telling that ang exiting
  move.b	#$1,d0	; indicating error
  rts
  
f_boot_cmd1_got_resp:
  movea.l	#f_boot_cmd1_resp_msg,a0	; saying we've got CMD1 response
  bsr	tx_str

f_boot_cmd16:
  move.b	#0,d2	; sending CMD16 - "set block size to 512 bytes"
  move.b	#0,d3	; that is not absoulutely needed, as I understand
  move.b	#BLOCKSIZE_H,d4
  move.b	#BLOCKSIZE_L,d5
  move.b	#SD_CMD16,d1
  bsr	sd_write_cmd_with_args_and_get_result
  cmpi.b		#$00,d0	;  sector should be 512 
  beq	f_boot_cmd16_ok
  movea.l	#f_boot_cmd16_not_ok_msg,a0
  bsr	tx_str	
  move.b	#$1,d0	; indicating error
  rts
f_boot_cmd16_ok:
  movea.l	#f_boot_cmd16_ok_msg,a0
  bsr	tx_str	

; CMD 10
f_boot_cmd10:

  IFD	DTZDOCMD10
  move.b	#SD_CMD10,d1 ; fetching card's name
  bsr	sd_write_cmd_and_get_result
  bsr	tx_b
;  move.w	#$80,d3
  move.w	#$10,d6
f_boot_cmd10_loop:
;  move.w	d3,-(sp)
  bsr	sd_read_byte
;  move.w	(sp)+,d3
  cmpi.b	#$FE,d0	; waiting for FE
  beq		f_boot_cmd10_done
  dbra	d6,f_boot_cmd10_loop
;  dbra	d3,f_boot_cmd10_loop
  movea.l	#f_boot_cmd10_not_ok_msg,a0
  bsr	tx_str	
  move.b	#$1,d0	; indicating error
  rts
  
f_boot_cmd10_done:
  movea.l	#f_boot_cmd10_got_fe,a0
  bsr	tx_str	

  bsr	sd_read_byte	; skipping manufacturer ID+smth else
  bsr	sd_read_byte
  bsr	sd_read_byte

  movea.l	#f_boot_card_id_msg,a0 ; saying "Card ID:"
  bsr	tx_str	
;  move.w	#$4,d3	; next 5 bytes are ASCII Card name
  move.w	#$4,d6	; next 5 bytes are ASCII Card name
f_boot_cmd10_done_loop2:
;  move.w	d3,-(sp)
  bsr	sd_read_byte
  bsr	tx_char
;  move.w	(sp)+,d3
;  dbra	d3,f_boot_cmd10_done_loop2	; 
  dbra	d6,f_boot_cmd10_done_loop2	; 
  move.b	#CR,d0
  bsr	tx_char
  move.b	#LF,d0
  bsr	tx_char
;  move.w	#$9,d3	; skip next 10 bytes
  move.w	#$19,d6	; skip next 10 bytes
f_boot_cmd10_done_loop3:
;  move.w	d3,-(sp)
  bsr	sd_read_byte
;  move.b	#'*',a
  bsr	tx_b
;  move.w	(sp)+,d3
  dbra	d6,f_boot_cmd10_done_loop3	; 
  ENDC ; DTZDOCMD10

f_boot_cmd58:
  move.b	#SD_CMD58,d1
  bsr	sd_write_cmd_and_get_result  ;and lets get 4 bytes of data
  IFD DTZSDDEBUG 
  bsr	tx_b
  ENDC
  cmpi.b	#$0,d0
  beq	f_boot_cmd58_ok
  move.l	#f_boot_cmd58_notok_msg,a0 ; that should not happen
  bsr	tx_str
  bra	f_boot_load	; that should not happen
f_boot_cmd58_ok:
  ; and lets get 4 bytes of data
  bsr	sd_read_byte ; First byte of OCR register
  andi	#$40,d0
  beq	f_boot_cmd58_not_sdhc
  move.l	#f_boot_is_sdhc_msg,a0
  move.b	#$1,f_boot_is_sdhc
  bra	f_boot_cmd_58_detected
f_boot_cmd58_not_sdhc:
  move.b	#$0,f_boot_is_sdhc
  move.l	#f_boot_isnot_sdhc_msg,a0
f_boot_cmd_58_detected:
  bsr	tx_str
  bsr	sd_read_byte	; and 3 last bytes of R3 data
  bsr	sd_read_byte
  bsr	sd_read_byte
; if we do just doing INIT card,uncomment this 
;	clr.b	d0 
;	rts

f_boot_load:
  movea.l	#boot_to,a5	; where we will boot it

  move.w	#$1F,d6	; will repeat 32 times = 16K
  ; for SD:
  move.b	#$0,d4  
  move.b	d4,d5
  ; d2 - always 0, d3 - always 0, d4 - from 0 to 40, d5 - 0
  ; for SDHC: d2 - always 0, d3 - always 0, d4 - 0, d5 - from 0 to 20 
f_boot_sector_loop:

  move.b	d6,-(sp)
  move.b	d4,-(sp)
  move.b	d5,-(sp)
  move.b	#$0,d2
  move.b	#$0,d3
  move.b	#SD_CMD17,d1 ; Reading actually
  bsr	sd_write_cmd_with_args_and_get_result
  IFD	DTZSDDEBUG
  move.b	f_boot_quiet,d6
  bne	f_boot_sec_lop_msg_skip
  bsr	tx_b
  move.l	#thatwhatcmd17said,a0
  bsr	tx_str
f_boot_sec_lop_msg_skip:
  ENDC
  move.w	#$4000,d3	; waiting for data token
f_boot_cmd17_loop:
  move.w	d3,-(sp)
  bsr	sd_read_byte
  move.w	(sp)+,d3
  cmpi.b	#$FE,d0	; waiting for FE
  beq		f_boot_cmd17_done
  dbra	d3,f_boot_cmd17_loop

  move.b	(sp)+,d4 ; cannot get FE - popping D5 (who cares where?)
  move.b	(sp)+,d4 ; cannot get FE - popping D4
  move.b	(sp)+,d4 ; cannot get FE - popping D6
  movea.l	#f_boot_cmd17_no_fe,a0
  bsr	tx_str
  move.b	#$1,d0	; indicating error
  rts

f_boot_cmd17_done:	; read data token done
  move.w	#BLOCKSIZE-1,d4 ; 512 bytes
f_boot_sector_read:
  move.w	d4,-(sp)	; byte counter
  bsr	sd_read_byte	; reading a byte from sector
  move.b	d0,(a5)+	; and storing it

;  move.b	#'*',d0		; shows every byte!
;  bsr	tx_char

  move.w	(sp)+,d4	; byte counter
  dbra	d4,f_boot_sector_read

  bsr	sd_read_byte	; reading and ignoring checksumm
  bsr	sd_read_byte	; again, checking it is a good idea

  move.b        f_boot_quiet,d6
  bne		f_boot_sector_rd_skp_msg
  move.l	#f_boot_sector_read_msg,a0
  bsr	tx_str
f_boot_sector_rd_skp_msg: 

  move.b	(sp)+,d5
  move.b	(sp)+,d4
  move.b	f_boot_is_sdhc,d0
;  move.b	#$1,f_boot_is_sdhc
;  ori.b	#$ff,a0	; or move should set the flag?
  beq	f_boot_sector_read_sd_incr
  addi.b	#1,d5	; this is sdhc
  bra	f_boot_sector_read_sd_incr_done
f_boot_sector_read_sd_incr:
  addi.b	#2,d4	; this is sd
f_boot_sector_read_sd_incr_done:
  move.b	(sp)+,d6
  dbra	d6,f_boot_sector_loop
  clr.b	d0	; indicating no error

  rts


; writes command in D1 ; returns D0 - ff if error, result if not
sd_write_cmd_and_get_result:
  bsr	sd_write_cmd
sd_write_cmd_and_get_result_preloop:
  move.w		#$7FFF,d1	; 64 tries in worst case
sd_write_cmd_and_get_result_loop:  
  move.w		d1,-(sp)
  bsr	sd_read_byte	; returns in D0
  move.w		(sp)+,d1
  cmpi.b		#$ff,d0
  bne	sd_write_cmd_and_get_result_done
  dbra	d1,sd_write_cmd_and_get_result_loop
sd_write_cmd_and_get_result_done:
  rts


; writes SD command D1, with no arguments
sd_write_cmd:
; should be there write FF? That's be good
; IT MUST!
  move.w		d1,-(sp)
  move.b	#$ff,d1
  bsr	sd_write_byte
  move.b	#$ff,d1
  bsr	sd_write_byte
  move.w		(sp)+,d1
; or may be ^^ that's not needed.
  bsr	sd_write_byte
  clr.b	d1
  bsr	sd_write_byte
  clr.b	d1
  bsr	sd_write_byte
  clr.b	d1
  bsr	sd_write_byte
  clr.b	d1
  bsr	sd_write_byte
  move.b		#$95,d1
  bsr	sd_write_byte
  rts

; writes command in D1 ; returns D0 - ff if error, result if not
; arguments d2,d3,d4,d5
sd_write_cmd_with_args_and_get_result:
  bsr	sd_write_cmd_with_args
  bra	sd_write_cmd_and_get_result_preloop ; the code is equal

; writes command in D1 ; returns D0 - ff if error, result if not
; arguments d2,d3,d4,d5
sd_write_cmd_with_args_and_checksumm_and_get_result:
  bsr	sd_write_cmd_with_args_and_checksumm
  bra	sd_write_cmd_and_get_result_preloop ; the code is equal


; writes SD command D1, with  arguments d2,d3,d4,d5
sd_write_cmd_with_args:
  move.b	#$95,d6 
sd_write_cmd_with_args_and_checksumm: 
  move.b	d6,-(sp)
  move.b	d5,-(sp)
  move.b	d4,-(sp)
  move.b	d3,-(sp)
  move.b	d2,-(sp)
  move.b	d1,-(sp)
  move.b	#$ff,d1
  bsr	sd_write_byte
;  move.b	#$ff,d1
;  bsr	sd_write_byte
  move.b		(sp)+,d1
  bsr	sd_write_byte
  move.b		(sp)+,d1
  bsr	sd_write_byte
  move.b		(sp)+,d1
  bsr	sd_write_byte
  move.b		(sp)+,d1
  bsr	sd_write_byte
  move.b		(sp)+,d1
  bsr	sd_write_byte
  move.b		(sp)+,d1
  bsr	sd_write_byte
  rts


; writes byte D1
sd_write_byte:
;  andi.l	#$000000FF,d1 ; that should be byte ; but looks like that's not needed

; delete this debug code
  IFD DTZSDDEBUG 
  move.b		d1,d7 ; storing d1 to d7
  move.b	f_boot_quiet,d1
  bne	sd_write_byte_skp_dbg
  move.b		#'[',d0
  bsr	tx_char
  move.b		#'W',d0
  bsr	tx_char
  move.b		#':',d0
  bsr	tx_char
  move.b		d7,d0
  bsr	tx_b
sd_write_byte_skp_dbg:
  move.b		d7,d1 ; restoring it back
  ENDC

; down to here
  move.l	d3,-(sp)
  move.w		#7,d3	; 8 bits in byte
sd_write_bit_loop:
  move.b		#0,d0
  add.b		d1,d1
  addx.b		d0,d0	; should add X==Carry flag,
  add.b		d0,d0	; 2 or 0
  move.b		d0,sd_port ; cs=0 data=data clock=0
  add.b		#$1,d0
  move.b		d0,sd_port ; cs=0 data=data clock=1
  subi.b	#$1,d0
  move.b		d0,sd_port ; cs=0 data=data clock=0

; this debug code should be deleted
;  move.b		d0,d7	; 
;  move.b		d1,d6	; 
;  move.b		#'.',d0
;  bsr	tx_char
;  move.b		d7,d0
;  addi.b		#'0',d7
;  bsr	tx_char  
;  move.b		d6,d1
;  move.b		d7,d0 ; restoring d0 d1
; -- up to here; no need to restore d0 bte

  dbra	d3,sd_write_bit_loop
  move.l	(sp)+,a3

  IFD DTZSDDEBUG 
  move.b	f_boot_quiet,d0
  bne	sd_write_exit_skp_msg
  move.b		#']',d0
  bsr	tx_char
sd_write_exit_skp_msg:
  ENDC
  rts

; returns on D0
sd_read_byte:
  move.w		#7,d3

;  move.b		#$0,d0	; here will be byte stored
  clr.l	d0
sd_read_byte_read_bit:
  add.b		d0,d0	; shifting it left
  move.b		#3,sd_port	; cs=0,data=1,clk=1

  move.b		sd_port,d1	; reading inverted data
  andi.b		#1,d1	; the lower bit is input
  eori.b		#1,d1	; we have an inverted data

  add.b		d1,d0	; adding to result

;  move.b		d0,d7
;  addi.b		#'0',d1  
;  move.b		d1,d0
;  bsr	tx_char
;  move.b		d7,d0

  move.b		#2,sd_port	; cs=0,data=1,clk=0


  dbra	d3,sd_read_byte_read_bit

;  move.b		d0,d7
;  move.b		#'(',d0
;  bsr	tx_char
;  move.b		#'R',d0
;  bsr	tx_char
;  move.b		#':',d0
;  bsr	tx_char
;  move.b		d7,d0
;  bsr	tx_b
;  move.b		#')',d0
;  bsr	tx_char
;  move.b		d7,d0
  rts


; send d1 ticks to sd card when cs high. Used by init.
sd_send_ticks_cs_high:
  move.w		d1,d7
  move.b		#$FF,sd_port	; cs=1 data=1 clock=up
;  move.w		#$0707,sd_port	; cs=1 data=1 clock=up
  IFNE	DTZSDDEBUG
  move.b	f_boot_quiet,d0
  bne	sd_send_ticks_cs_high_skp_msg
  move.b		#'^',d0
  bsr	tx_char
sd_send_ticks_cs_high_skp_msg:
  ENDC
  move.b		#$FE,sd_port	; cs=1 data=1 clock=low
;  move.w		#$0606,sd_port	; cs=1 data=1 clock=low
  IFNE  DTZSDDEBUG
  move.b        f_boot_quiet,d0
  bne   sd_send_ticks_cs_high_skp2_msg
  move.b		#'v',d0
  bsr	tx_char
sd_send_ticks_cs_high_skp2_msg:
  ENDC
  move.w	d7,d1
  dbra	d1,sd_send_ticks_cs_high
  rts
  
; Uppers CS
sd_cs_high:
;  move.w		#$0606,sd_port	; cs=1,data=1,clk=0
  move.b		#$FE,sd_port	; cs=1,data=1,clk=0
  rts
; Lowers CS
sd_cs_low:
;  move.w		#$0202,sd_port	; cs=0,data=1,clk=0
  move.b		#$FA,sd_port	; cs=0,data=1,clk=0
  rts
  
 
;significant_delay:
;	move.w	d0,-(sp)
;	move.w	#$7FFF,d0
;signdelay1:
;	dbra	d0,signdelay1
;	move.w	(sp)+,d0
;	rts
  
f_boot_is_sdhc:
	dc.b	0	
f_boot_quiet:
	dc.b	1
f_boot_msg:
  dc.b	'Booting',CR,LF,0
f_boot_cmd0_done_msg:
  dc.b	'CMD0 send',CR,LF,0
f_boot_cmd0_no_resp_msg:
  dc.b	'CMD0 no response',CR,LF,0
f_boot_cmd0_resp_msg:
  dc.b	'CMD0 got 01!',CR,LF,0
f_boot_cmd8_resp_msg:
  dc.b	'CMD8 returned ',0
f_boot_cmd8_ununderstood_msg:
  dc.b	'CMD8 ununderstood (got 5)',CR,LF,0
f_boot_cmd8_noreply_msg:
  dc.b	'CMD8 -got no reply!',CR,LF,0
f_boot_cmd8_ok_msg
  dc.b	'CMD8 -got it!',CR,LF,0
f_boot_cmd8_notv2_msg:
  dc.b	'Card is not V2',CR,LF,0
f_boot_cmd8_isv2_msg:
  dc.b	'Card is V2',CR,LF,0  
f_boot_acmd41_msg_failed:
  dc.b	'ACMD41: cannot switch from IDLE mode',CR,LF,0
f_boot_acmd41_msg_ok:
  dc.b	'ACMD41: got it',CR,LF,0
f_boot_cmd1_no_resp_msg:
  dc.b	'CMD1 no response',CR,LF,0
f_boot_cmd1_resp_msg:
  dc.b	'CMD1 got 00',CR,LF,0
f_boot_cmd16_ok_msg:
  dc.b	'CMD16 got 00',CR,LF,0
f_boot_cmd16_not_ok_msg:
  dc.b	'CMD16 failed - cannot set 512 b/sec',CR,LF,0
f_boot_cmd10_not_ok_msg:
  dc.b	'CMD10 failed - cannot get FE',CR,LF,0
f_boot_cmd10_got_fe:
  dc.b	'CMD10 got FE',CR,LF,0
f_boot_cmd58_notok_msg:
  dc.b	'CMD58 failed',CR,LF,0
f_boot_is_sdhc_msg:
  dc.b	'SDHC card',CR,LF,0
f_boot_isnot_sdhc_msg:
  dc.b	'SD card',CR,LF,0

f_boot_card_id_msg:
  dc.b	'Card ID:',0
  IFD DTZSDDEBUG
f_boot_sector_read_msg:
  dc.b	'Sector Read',CR,LF,0
thatwhatcmd17said:
  dc.b	'<- CMD17 said',CR,LF,0
  ENDIF
  IFND DTZSDDEBUG
f_boot_sector_read_msg:
  dc.b	'.',0
  ENDIF
  
f_boot_cmd17_no_fe:
  dc.b	'Cannot get data token for CMD17',CR,LF,0
  even
