//#define DEBUG


/* Really, with WITH_CTS means with RTS: tell the other side that we 
do not want to accept more chars right noq */ 

#define WITH_CTS 1
#ifdef WITH_CTS
//#define RX_BUF_SIZE 32
//#define RX_BUF_MASK 0x1F
#define RX_BUF_SIZE 256
#define RX_BUF_MASK 0xFF // Meaning bytes of RX_BUF_SIZE; must match!
#endif

/* And this - suprise! - means exactly what written: check if the
remote wants to accept more chars with CTS */
#define CHECK_CTS

/* if you want break on serial to lead to reset -
uncomment next line */ 
#define BREAK_TO_RESET 1

//#define ROTATING_SHIT 1
//#define WITH_WATCHDOG

/* Here the clocks will be clicked */
#define CLK_DDR DDRC
#define CLK_PIN PC0
#define CLK_PORT PORTC
/* And this is the reset port */
#define RESET_DDR DDRC
#define RESET_PIN PC2
#define RESET_PORT PORTC

/* R/~W pin. */
#define RDWR_DDR DDRC
#define RDWR_PIN PC3
#define RDWR_PORT PORTC
#define RDWR_PORTIN PINC

/* BOOTMODE pin */
#define BOOTMODE_DDR DDRC
#define BOOTMODE_PIN PC1
#define BOOTMODE_PORT PORTC
#define BOOTMODE_PORTIN PINC

#ifdef CHECK_CTS
/* RTS pin */
#define CTS_DDR DDRD
#define CTS_PIN PD4
#define CTS_PORT PORTD
#define CTS_PORTIN PIND
#endif

#ifdef WITH_CTS
/* RTS pin */
#define RTS_DDR DDRC
#define RTS_PIN PC5
#define RTS_PORT PORTC
#define RTS_PORTIN PINC
#endif


/* A1 pin */
/* A1 pin is used when CPU tries to read from MCU
as UART mode. If it is 1, send status, if 0 - send recived byte */
#define A1_DDR DDRC
#define A1_PIN PC4
#define A1_PORT PORTC
#define A1_PORTIN PINC


/* DTACK pin */
//#define DTACK_DDR DDRC
//#define DTACK_PIN PC4
//#define DTACK_PORT PORTC
//#define DTACK_PORTIN PINC

#define WR_DDR DDRC
#define WR_PIN PC1
#define WR_PORT PORTC
#define WR_PORTIN PINC

#ifndef DTZ_SERIO
void uart_puti(int val );
void uart_puthex_nibble(unsigned char b);
void uart_puthex_byte(unsigned char  b);
void USART_PUTCH(char ch);
void USART_PUTS_my(const unsigned char *s);
void USART_Init(unsigned int ubrr);
uint8_t USART_READY_TO_SEND();
#ifdef WITH_RTS
void rts_up();
void rts_down();
#endif
#ifdef WITH_CTS
void rts_up();
void rts_down();
#endif
#endif

#ifndef DTZ_MAIN
void USART_PUTCH(char ch);
extern /* static  */ volatile  long int reset_ticks;
//extern static int reset_ticks;
extern volatile char bootmode;
extern volatile char writing_on_bus;
#endif

#ifndef DTZ_PORT_FUNC
//extern /* static  */ volatile uint8_t has_byte_in_input;
void setioports();
void data_bus_to_read(void);
void writebyte(unsigned char b);
void reset_CPU();
void reset_forever();
void release_reset_CPU();
void click_clock();
unsigned char read_data_bus();
void enter_bootmode();
void exit_bootmode();
#endif

int bytefeeder();
