#define DTZ_SERIO
//#include <avr/pgmspace.h>

#include <avr/io.h>
#include <inttypes.h>
#include <avr/pgmspace.h>
#include "main.h"

#ifdef WITH_CTS
// or maybe rts_up is really rts_down, and vice versa
void rts_down()
{
 RTS_PORT |= _BV(RTS_PIN);
// RTS_PORT &= ~_BV(RTS_PIN);
}

void rts_up()
{
// RTS_PORT |= _BV(RTS_PIN);
 RTS_PORT &= ~_BV(RTS_PIN);
}
#endif 


/*************************************************************************
Function: uart_puthex_nibble()
Purpose:  transmit lower nibble as ASCII-hex to UART
Input:    byte value
Returns:  none
This functions has been added by Martin Thomas <eversmith@heizung-thomas.de>
Don't blame P. Fleury if it doesn't work ;-)
**************************************************************************/
void uart_puthex_nibble(unsigned char b)
{
    unsigned char  c = b & 0x0f;
    if (c>9) c += 'A'-10;
    else c += '0';
    USART_PUTCH(c);
} /* uart_puthex_nibble */

/*************************************************************************
Function: uart_puthex_byte()
Purpose:  transmit upper and lower nibble as ASCII-hex to UART
Input:    byte value
Returns:  none
This functions has been added by Martin Thomas <eversmith@heizung-thomas.de>
Don't blame P. Fleury if it doesn't work ;-)
**************************************************************************/
void uart_puthex_byte(unsigned char  b)
{
    uart_puthex_nibble(b>>4);
    uart_puthex_nibble(b);
} /* uart_puthex_byte */

/************************************* Whole Serial/RS232 stuff ************/
void USART_Init(unsigned int ubrr)
{
 UBRRH = ((unsigned char)(ubrr>>8));
 UBRRL = (unsigned char)ubrr;  /* 0 and 5 for 2400@1Mhz */
// This (URSEL) is specific to Atmega8, check for other devices
 UCSRC = (1 << URSEL) |(1 << UCSZ1) | (1 << UCSZ0);    // Set frame: 8data, 1 stp
 UCSRB = (1<<RXEN)|(1<<TXEN);
}
     
void USART_PUTCH(char ch)
{ 
 while ((UCSRA & (1 << UDRE)) == 0);   // Wait until buffer is empty
 UDR = ch;                     // Send the data to the TX buffer
}

// Returns 0 is USART is ready to send
// Returns exactly 1 if not
uint8_t USART_READY_TO_SEND()
{
#ifndef CHECK_CTS 
 return  ( ((UCSRA & (1 << UDRE)) == 0 ) ? 1 : 0);
#else
 return  ( 
  ((CTS_PORTIN & _BV(CTS_PIN)) ? 1 : 0)
   ||
  (((UCSRA & (1 << UDRE)) == 0 ) ? 1 : 0)
 );
#endif
}
        
         
void USART_PUTS_my(const unsigned char *s)
{
 static int sp;
 sp = 0;
 while (pgm_read_byte(s+sp)) {
  USART_PUTCH(pgm_read_byte(s+sp));
  sp++;
 }
}
